<?php
    require_once( "../../../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "../../auth.php" );
    
    $action = array_key_exists( 'action', $_REQUEST )?$_REQUEST['action']:null;
    $service = array_key_exists( 'service', $_REQUEST )?$_REQUEST['service']:null;
    $rule = array_key_exists( 'rule', $_REQUEST )?$_REQUEST['rule']:null;

    if ( isset( $rule ) )
    {
        $rule = strtolower( $rule );
    }
    
    require_once( "core/db/tables/SLAACTable.php" );
    require_once( "core/access/sl_agent_patterns.php" );

    $table = new SLAACTable( $db );

    if( isset( $action  ) )
    {
        if ( $action == "add_common" )
        {
            $agent = $_REQUEST["common_agent"];
            $table->createAACEntry( _SL_AAC_COMMON, $agent, $rule, $service );
        }
        else if ( $action == "add_simple" )
        {
            $type = $_REQUEST["type"];
            $pattern = $_REQUEST["pattern"];
            $table->createAACEntry( $type, $pattern, $rule, $service );
        }
        else if ( $action == "add_regex" )
        {
            $pattern = $_REQUEST["reg_ex"];
            $table->createAACEntry( _SL_AAC_REGEX, $pattern, $rule, $service );
        }
        else if ( $action == "delete" )
        {
            $delete = $_REQUEST["delete_list"];
            $keys = array_keys( $delete );
            foreach( $keys as $key )
            {
                $table->deleteAACEntryById( $key );
            }
        }
    }
   
     // This is nasty....
    switch ( $service )
    {
        case _SL_AAC_BROWSE:
            $service_name = "Browse";
            break;
        
        case _SL_AAC_STREAM:
            $service_name = "Stream";
            break;
        
        case _SL_AAC_DOWNLOAD:
            $service_name = "Download";
            break;
    }
    
    switch ( $rule )
    {
        case _SL_AAC_ALLOW:
            $rule_name = "Allow";
            break;
        
        case _SL_AAC_DENY:
            $rule_name = "Deny";
            break;
    }
   
    $entries = $table->getEntriesByServiceAndRule( $service, $rule );
    
    $sl_admin_nav_links = array( 
        "Home" => "../../index.php", 
        "Agent Access" => "agent_access.php", 
        "$service_name Access" => "edit_agent_access?service=$service",
        "Edit $rule_name Rules" => "" );

    require_once( "core/theme/SLPageInfo.php" );
    $sl_page_info = &new SLPageInfo( 
        SL_ADMIN_PAGE, 
        "Streamline Administration", 
        "$service_name Agent Access $rule_name Rules", 
        "" );

    require( "core/theme/includes/admin_header.php" );
?>
      <script language="javascript" type="text/javascript" src="access.js" ></script>
      <table width="100%">
        <tr>
          <td valign="top">
            <form action="edit_aac_rule.php" id="rules_form">
              <input type="hidden" name="action" value="delete">
              <input type="hidden" name="service" value="<?php echo $service; ?>">
              <input type="hidden" name="rule" value="<?php echo $rule; ?>">
              <table style='border: 1px solid black;' width="100%">
                <tr>
                  <td style='border-bottom: 1px solid black' colspan="2">
                    <table width='100%'>
                      <tr>
                        <td style='border-bottom: 1px solid black'><h3>Current Rules</h3></td>
                      </tr>
                      <tr>
                        <td>
                          <table bgcolor='#CCCCCC' width='100%' style='border: 1px solid black'>
                            <tr>
                              <th></th>
                              <th>From</th>
                              <th>To</th>
                            </tr>
                            <?php
                              foreach( $entries as $entry )
                              {
                                switch ( $entry->getPatternType() )
                                {
                                    case _SL_AAC_IS:
                                        $type = "Is";
                                        $pattern = $entry->getPattern();
                                        break;

                                    case _SL_AAC_CONTAINS:
                                        $type = "Contains";
                                        $pattern = $entry->getPattern();
                                        break;

                                    case _SL_AAC_REGEX:
                                        $type = "Reg Ex";
                                        $pattern = $entry->getPattern();
                                        break;

                                    case _SL_AAC_COMMON:
                                        $type = "Common Agent";
                                        $pattern = getSLAgentName( $entry->getPattern() );
                                        break;
                                }
                            ?>
                            <tr>
                              <td bgcolor='#EEEEEE'>
                                <input type="checkbox" name="delete_list[<?php echo $entry->getEntryId(); ?>]">
                              </td>
                              <td style='padding-right: 20px;' bgcolor='#EEEEEE'><?php echo $type; ?></td>
                              <td style='padding-right: 20px;' bgcolor='#EEEEEE'><?php echo $pattern; ?></td>
                            </tr>
                            <?php
                              }
                            ?>
                          </table>
                        </td>
                      </tr>
                    </table>
                  </td>
                </tr>
                <tr>
                  <td align='left'>
                    <input type='button' onClick="handleSelect( true )" value='Select All'>
                    <input type='button' onClick="handleSelect( false )" value='Deselect All'>
                  </td>
                  <td align='right'>
                    <input type='submit' value='Delete'>
                  </td>
                </tr>
              </table>
            </form>
          </td>
          <td style="padding-left: 30px" valign="top">
            <table width="100%">
              <tr>
                <td>
                  <form action="edit_aac_rule.php" method="get">
                    <input type="hidden" name="action" value="add_common">
                    <input type="hidden" name="service" value="<?php echo $service; ?>">
                    <input type="hidden" name="rule" value="<?php echo $rule; ?>">
                    <table width="100%" style="border: 1px solid black">
                      <tr>
                        <td colspan="2">
                          Add Commen Agents:
                        </td>
                      </tr>
                      <tr>
                        <td>
                          Agent Name:
                          <select name="common_agent">
                          <?php
                            $keys = array_keys( $sl_agent_patterns );
                            
                            foreach( $keys as $key )
                            {
                                $name = getSLAgentName( $key );
                          ?>
                            <option value="<?php echo $key; ?>"><?php echo $name; ?></option>
                          <?php
                            }
                          ?>
                          </select>
                        </td>
                        <td>
                          <input type="submit" name="add" value="Add">
                        </td>
                      </tr>
                    </table>
                  </form>
                </td>
              </tr>
              <tr>
                <td style="padding-top: 15px">
                  <form action="edit_aac_rule.php" method="get">
                    <input type="hidden" name="action" value="add_simple">
                    <input type="hidden" name="service" value="<?php echo $service; ?>">
                    <input type="hidden" name="rule" value="<?php echo $rule; ?>">
                    <table width="100%" style="border: 1px solid black">
                      <tr>
                        <td colspan="3">
                          Add Simple Pattern: 
                        </td>
                      </tr>
                      <tr>
                        <td>
                          Evaluation Rule:
                          <select name="type">
                            <option value="<?php echo _SL_AAC_CONTAINS; ?>">Contains</option>
                            <option value="<?php echo _SL_AAC_IS; ?>">Is</option>
                          </select>
                        </td>
                        <td>
                          Pattern: <input type="text" name="pattern">
                        </td>
                        <td>
                          <input type="submit" name="add" value="Add">
                        </td>
                      </tr>
                    </table>
                  </form>
                </td>
              </tr>
                <td style="padding-top: 15px">
                  <form action="edit_aac_rule.php" method="get">
                    <input type="hidden" name="action" value="add_regex">
                    <input type="hidden" name="service" value="<?php echo $service; ?>">
                    <input type="hidden" name="rule" value="<?php echo $rule; ?>">
                    <table width="100%" style="border: 1px solid black">
                      <tr>
                        <td colspan="2">
                          Add Regular Expression:
                        </td>
                      </tr>
                      <tr>
                        <td>
                          Regular Expression: <input type="text" size="25" name="reg_ex">
                        </td>
                        <td>
                          <input type="submit" name="add" value="Add">
                        </td>
                      </tr>
                    </table>
                  </form>
                </td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
      <a href="edit_agent_access.php?service=<?php echo $service; ?>">Back</a>
<?php
    require_once( "core/theme/includes/admin_footer.php" );
?>
