<?php
    require_once( "../../../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "admin/auth.php" );
    require_once( "core/db/tables/SLUserTable.php" );
   
    $edit_op = array_key_exists( 'edit_op', $_REQUEST )?$_REQUEST['edit_op']:null;
    $service = array_key_exists( 'service', $_REQUEST )?$_REQUEST['service']:null;
    $users = array_key_exists( 'users', $_REQUEST )?$_REQUEST['users']:null;
    $user_table = new SLUserTable( $db );
    
    if ( isset( $edit_op ) )
    {
        if ( $edit_op == "Ok" )
        {  
            $everyone_access = false;
            $key = array_search( "EVERYONE", $users ); 
            if (  is_int( $key ) )
            {
                $everyone_access = true;
                unset( $users[$key] );
            }

            
            require_once( "core/db/tables/SLConfigTable.php" );
            $table = new SLConfigTable( $db );
            
            // This is nasty....
            switch ( $service )
            {
                case "browse":
                    $opt = $table->getOption( "BrowsingRequiresAuth" );
                    $opt->setValue( !$everyone_access?"yes":"no" );
                    $sl_config->setBrowsingRequiresAuth( !$everyone_access );
                    break;
                
                case "stream":
                    $opt = $table->getOption( "StreamingRequiresAuth" );
                    $opt->setValue( !$everyone_access?"yes":"no" );
                    $sl_config->setStreamingRequiresAuth( !$everyone_access );
                    break;
                
                case "download":
                    $opt = $table->getOption( "DownloadingRequiresAuth" );
                    $opt->setValue( !$everyone_access?"yes":"no" );
                    $sl_config->setDownloadingRequiresAuth( !$everyone_access );
                    break;
                
                case "admin":
                    $opt = $table->getOption( "AdminRequiresAuth" );
                    $opt->setValue( !$everyone_access?"yes":"no" );
                    $sl_config->setAdminRequiresAuth( !$everyone_access );
                    break;
            }

            $user_table->setUsersPrivilege( $service, $users );
            $sl_access_controler->evaluate( $db, $sl_config );
            
            header( "Location: user_privileges.php" );
            echo "\n";
            die();
        }
        else
        {
            header( "Location: user_privileges.php" );
            echo "\n";
            die();
        }
    }
   
    $everyone_access = false;
    
    $available = array ();
    $selected = array();

    $users_with = null;
    $users_without = null;
    $service_title = null;
    
    switch ( $service )
    {
        case "browse":
            $everyone_access = !$sl_config->getBrowsingRequiresAuth();
            $users_with = $user_table->getUsersByPrivelege( "browse", 1 );
            $users_without = $user_table->getUsersByPrivelege( "browse", 0 );
            $service_title = "Browse";
            break;
        
        case "stream":
            $everyone_access = !$sl_config->getStreamingRequiresAuth();
            $users_with = $user_table->getUsersByPrivelege( "stream", 1 );
            $users_without = $user_table->getUsersByPrivelege( "stream", 0 );
            $service_title = "Stream";
            break;
        
        case "download":
            $everyone_access = !$sl_config->getDownloadingRequiresAuth();
            $users_with = $user_table->getUsersByPrivelege( "download", 1 );
            $users_without = $user_table->getUsersByPrivelege( "download", 0 );
            $service_title = "Download";
            break;
        
        case "admin":
            $everyone_access = !$sl_config->getAdminRequiresAuth();
            $users_with = $user_table->getUsersByPrivelege( "admin", 1 );
            $users_without = $user_table->getUsersByPrivelege( "admin", 0 );
            $service_title = "Admin";
            break;
    } 


    if ( $everyone_access )
    {
        $selected["EVERYONE"] = "EVERYONE";
    }
    else
    {
        $available["EVERYONE"] = "EVERYONE";
    }

    foreach( $users_with as $user )
    {
        $selected[$user->getUserName()] = $user->getUserName();
    }
    
    foreach( $users_without as $user )
    {
        $available[$user->getUserName()] = $user->getUserName();
    }
    
    $sl_admin_nav_links = array( "Home" => "../../index.php", "User Privileges" => "user_privileges.php", "$service_title Privileges" => "");

    require_once( "core/theme/SLPageInfo.php" );
    $sl_page_info = &new SLPageInfo( 
        SL_ADMIN_PAGE, 
        "Streamline Administration", 
        "$service_title Privileges", 
        "createListObjects()" );

    require( "core/theme/includes/admin_header.php" );
?>
      <script src="privileges.js" type="text/javascript" language="javascript"></script>
      <p>
       This dialog will allow you to choose which users have <?php echo $service ?> priveleges. 
      </p>
    <form id="users" action="edit_user_privileges.php" method="get" onSubmit="preProcessSubmit( this )">
      <input type="hidden" name="service" value="<?php echo $service; ?>">
      <table border="0" width="400" bgcolor="#CCCCCC" style="border: solid 1px black">
        <tr>
           <td align="center"><strong>Available Users</strong></td>
           <td></td>
           <td align="center"><strong>Selected Users</strong></td>
           <td></td>
        </tr>
        <tr>
          <td>
            <select style="height: 200px; width: 200px;" onClick="deselectSelectedList()" size=2 id="availableUsers" name="availableUsers" onChange="updateButtonState()">
              <?php
                foreach( array_keys( $available ) as $key )
                {
                    $value = $available[$key];
                    echo "<option value='$key'>$value</option>\n";
                }
              ?>
            </select>
          </td>
          <td valign="middle" align="center" >
            <input type="button" onclick="addAttribute()" id="add_button" value="Add"> 
            <br>
            <input type="button" onclick="delAttribute()" id="remove_button" value="Remove"> 
          </td>
          <td>
            <select size="4" onClick="deselectAvailableList()" style="height: 200px; width: 200px;" id="selectedUsers" name="selectedUsers" onChange="updateButtonState()">
              <?php
                foreach( array_keys( $selected ) as $key )
                {
                    $value = $selected[$key];
                    echo "<option value='$key'>$value</option>\n";
                }
              ?>
            </select>
          </td>
        </tr>
        <tr>
          <td colspan="3">
            <hr>
          </td>
        </tr>
        <tr>
          <td colspan="4" align="right">
            <input type="submit" name="edit_op" value="Cancel">
            <input type="submit" name="edit_op" value="Ok">
          </td>
          <td>
          </td>
        </tr>
      </table>
    </form>

<?php
    require_once( "core/theme/includes/admin_footer.php" );
?>
