var selectedList;
var availableList;

var add;
var remove;
var up;
var down;

Node.prototype.swapNode = function (node) 
{
  var nextSibling = this.nextSibling;
  var parentNode = this.parentNode;
  node.parentNode.replaceChild(this, node);
  parentNode.insertBefore(node, nextSibling);  
}

function createListObjects()
{
    availableList = document.getElementById("availableUsers");
    selectedList = document.getElementById("selectedUsers");

    add = document.all ? document.all["add_button"] : document.getElementById( "add_button" );
    remove = document.all ? document.all["remove_button"] : document.getElementById( "remove_button" );

    updateButtonState();
}

function delAttribute()
{
   var selIndex = selectedList.selectedIndex;
   if(selIndex < 0)
      return;
      
    var option = selectedList.options.item( selIndex );
  
    if ( option.value == "EVERYONE" )
    {
        availableList.insertBefore(option, availableList.options.item(0) );
    }
    else
    {
        availableList.appendChild( option );
    }
    
   selectNone(selectedList,availableList);
   setSize(availableList,selectedList);

    updateButtonState();
}

function addAttribute()
{
    var addIndex = availableList.selectedIndex;
    if(addIndex < 0)
        return;
    var option = availableList.options.item( addIndex );
  
    if ( option.value == "EVERYONE" )
    {
        selectedList.insertBefore(option, selectedList.options.item(0) );
    }
    else
    {
        selectedList.appendChild( option );
    }
  
    selectNone(selectedList,availableList);
    setSize(selectedList,availableList);

    updateButtonState();
}

function setSize(list1,list2)
{
    list1.size = getSize(list1);
    list2.size = getSize(list2);
}

function selectNone(list1,list2)
{
    list1.selectedIndex = -1;
    list2.selectedIndex = -1;
    addIndex = -1;
    selIndex = -1;
}

function getSize(list)
{
    /* Mozilla ignores whitespace, 
       IE doesn't - count the elements 
       in the list */
    var len = list.childNodes.length;
    var nsLen = 0;
    //nodeType returns 1 for elements
    for(i=0; i<len; i++){
        if(list.childNodes.item(i).nodeType==1)
            nsLen++;
    }
    if(nsLen<2)
        return 2;
    else
        return nsLen;
}

function moveUp()
{
    if ( selectedList.selectedIndex < 1 )
        return;

    var sel = selectedList.options.item(selectedList.selectedIndex );
    sel.swapNode( sel.previousSibling );

    updateButtonState();
}

function moveDown()
{
    if ( selectedList.selectedIndex < 0 )
        return;

    var sel = selectedList.options.item(selectedList.selectedIndex );
    sel.nextSibling.swapNode( sel );

    updateButtonState();
}

function updateButtonState()
{
    var availableIndex = availableList.selectedIndex;
    var selectedIndex = selectedList.selectedIndex;

    add.disabled = availableIndex < 0;
    remove.disabled = selectedIndex < 0;
}


function preProcessSubmit( form )
{
    var options = selectedList.getElementsByTagName( "option" );
    
    for ( var i=0; i < options.length; i++ )
    {
        var cur = options[i];
        var input = document.createElement( 'input' );

        if ( document.all )
        {
            input.type = "hidden";
            input.name = form.id + "[]";
            input.value = cur.value;
        }
        else
        {
            input.setAttribute( 'type', "hidden" );
            input.setAttribute( 'name', form.id + "[]" );
            input.setAttribute( 'value', cur.value );
        }

        form.appendChild( input );
    }
}

function deselectSelectedList()
{
    selectedList.selectedIndex = -1;

    updateButtonState();
}

function deselectAvailableList()
{
    availableList.selectedIndex = -1;

    updateButtonState();
}
