var color = "#0088DD";
var typeTable;

function init()
{
    typeTable = new SelectionTable("typeTable");
    typeTable.selectionListener = handleTableSelection;
    typeTable.doubleClickListener = handleDoubleClick;
    
    var add = document.all ? document.all["type_add"] : document.getElementById( "type_add" );
    var remove = document.all ? document.all["type_remove"] : document.getElementById( "type_remove" );
    var edit = document.all ? document.all["type_edit"] : document.getElementById( "type_edit" );

    remove.disabled = true;
    edit.disabled = true;
}

function handleRemove()
{
    var url = "remove_type.php?";
    
    var selected = typeTable.selected;
    
    for ( var i=0; i < selected.length; i++ )
    {
        url += "types[" + i + "]=" + selected[i].id;
        
        if ( i != selected.length - 1 )
        {
            url += "&";
        }
    }
            
    RemoveWindow=window.open(url,'RemoveMediaType','toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=yes,width=450,height=336');
    return false;
}

function handleEdit()
{
    
    var selected = typeTable.selected;
    var url = "edit_type.php?ext=" + selected[0].id;
    
            
    EditWindow=window.open(url,'EditMediaType','toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=yes,width=450,height=336');
    return false;
}

function handleTableSelection( table )
{
    var remove = document.all ? document.all["type_remove"] : document.getElementById( "type_remove" );
    var edit = document.all ? document.all["type_edit"] : document.getElementById( "type_edit" );

    edit.disabled = table.selected.length != 1;
    remove.disabled = table.selected.length < 1;
}

function handleDoubleClick()
{
    var edit = document.all ? document.all["type_edit"] : document.getElementById( "type_edit" );
    edit.click();
}

Node.prototype.swapNode = function (node) 
{
  var nextSibling = this.nextSibling;
  var parentNode = this.parentNode;
  node.parentNode.replaceChild(this, node);
  parentNode.insertBefore(node, nextSibling);  
}

function SelectionTable( tableId )
{
    this.selected = new Array(0);
	this.table = 
	    document.all ? document.all[tableId] : document.getElementById( tableId );

    if( !document.all )
    {
        this.table.onselectstart = false;
    }
    
	this.lastClicked = null;
	
	this.processClick = function( e, clickedRow ) 
    {
        var ctrlClick = this.isControl( e );
        var shiftClick = this.isShift( e );
	    	
        if ( shiftClick )
		{
            for ( var i=0; i < this.selected.length; i++ )
            {
                var cur = this.selected[i];
                this.unhighlight( cur );
            }

            var start;
			if ( this.lastClicked != null )
			{
			    start = this.lastClicked;
			}
			else
			{
				start = clickedRow;
				this.lastClicked = clickedRow;
			}
			var startIndex = ( start.rowIndex < clickedRow.rowIndex ? start.rowIndex : clickedRow.rowIndex );
			var endIndex = ( start.rowIndex > clickedRow.rowIndex ? start.rowIndex : clickedRow.rowIndex );
			this.selected = new Array(0);
            var rows = this.table.getElementsByTagName( "tr" );
			
			for ( var i = startIndex; i <= endIndex; i++ )
		    {	
                this.selected[this.selected.length] = rows.item(i);
				this.highlight( rows.item(i) );
			}			
		}
		else if ( ctrlClick )
        {
            this.lastClicked = clickedRow;
			if ( this.isSelected( clickedRow ) )
            {
                this.unhighlight( clickedRow );
                this.selected = this.remove( this.selected, clickedRow );
            }
            else
            {
                this.selected[this.selected.length] = clickedRow;
                this.highlight( clickedRow );
            }
        }
        else
        {
		    this.lastClicked = clickedRow;
            for ( var i=0; i < this.selected.length; i++ )
            {
                var cur = this.selected[i];
                this.unhighlight( cur );
            }
			 
            this.selected = new Array( 1 );
            this.selected [0] = clickedRow;
            this.highlight( clickedRow );
        }
		
		this.selectionListener( this );
    }
    
	this.processDoubleClick = function()
    {
       this.doubleClickListener();        
    }
	
    this.doubleClickListener = function()
    {

    }

    
    this.handleUp = function()
    {
        var rows = this.table.getElementsByTagName( "tr" );
        var selected = this.selected[0];
        
        for ( var i = 0; i < rows.length; i++ )
        {
            var row = rows[i];
            if ( ( row == selected ) && ( i != 0 ) )
            {
                row.swapNode( rows[i-1] );
                break;
            }
        }
        this.renumber();
    }
    
    this.handleDown = function()
    {
        var rows = this.table.getElementsByTagName( "tr" );
        var selected = this.selected[0];
        
        for ( var i = 0; i < rows.length; i++ )
        {
            var row = rows[i];
            if ( ( row == selected ) && ( i < rows.length - 1 ) )
            {
                row.swapNode( rows[i+1] );
                break;
            }
        }
        this.renumber();
    }   
    
    this.handleDelete = function()
    {
        var tbody = this.table.getElementsByTagName( "tbody" );
        for ( var i=0; i < this.selected.length; i++ )
        {
            var cur = this.selected[i];
            cur.parentNode.removeChild( cur );
        }
        
        this.renumber();
    }

    this.renumber = function()
    {
        var rows = this.table.getElementsByTagName( "tr" );
        
        for ( var j = 0; j < rows.length; j++ )
        {	
            var row = rows[j];
            var tds = row.getElementsByTagName( "td" );
            var td0 = tds[0];
            var fonts = td0.getElementsByTagName("font");
            fonts[0].firstChild.nodeValue = (j + 1);
        }
    }
    
    this.preprocessSubmit = function( form )
    {
        var rows = this.table.getElementsByTagName( "tr" );
        
        for ( var i=0; i < rows.length; i++ )
        {
            var cur = rows[i];
            var input = document.createElement( 'input' );

	        if ( document.all )
            {
                input.type = "hidden";
                input.name = this.table.id + "[]";
                input.value = cur.id;
            }
            else
            {
                input.setAttribute( 'type', "hidden" );
                input.setAttribute( 'name', this.table.id + "[]" );
                input.setAttribute( 'value', cur.id );
            }

            form.appendChild( input );
        }
    }

    this.isSelected = function( object )
    {
        var found = false;
		
        for ( var i=0; i < this.selected.length && !found; i++ )
        {
            var cur = this.selected[i];
            found = ( cur == object );
        }
		
        return found;
    }

    // Listners that can be overridden
	this.selectionListener = new Function( "table", "" );

	
    // Helper Functions
    this.remove = function( array, object )
    {
        var result = new Array( array.length - 1 );
        var newIndex = 0;
		
        for ( var i=0; i < array.length; i++ )
        {
            if ( array[i] != object )
            {
                result[newIndex] = array[i];
                newIndex++;
            }
        }
		
        return result;
    }


    this.highlight = function( obj )
    {
    	if ( document.layers ) 
        {
            var lyr = document.layers[obj.id]
            lyr.document.bgColor = color
            lyr.document.color = "white";
        }
        else
        {
            obj.style.backgroundColor = color
            obj.style.color = "white";
        }
    }

    this.unhighlight = function( obj )
    {
        if ( document.layers ) 
        {
            var lyr = document.layers[obj.id]
            lyr.document.bgColor = "";
            lyr.document.color = "";
        }
        else
        {
            obj.style.backgroundColor = "";
            obj.style.color = "";
        }
    }

    this.isControl = function( e )
    {
        var nav4 = window.Event ? true : false;
        return (nav4 && (e.modifiers & Event.CONTROL_MASK)) || e.ctrlKey;
    }

    this.isShift = function( e )
    {
        var nav4 = window.Event ? true : false;
        return (nav4 && (e.modifiers & Event.SHIFT_MASK)) || e.shiftKey;
    }    
}
