var color = "#0088DD";
var typeTable;

function init()
{
    typeTable = new SelectionTable("typeTable");
    typeTable.selectionListener = handleTableSelection;
    typeTable.doubleClickListener = handleDoubleClick;
    init_list( typeTable );
}

function handleTableSelection( table )
{
}

function handleDoubleClick()
{
}

function SelectionTable( tableId )
{
    this.selected = new Array(0);
	this.table = 
	    document.all ? document.all[tableId] : document.getElementById( tableId );
    
    if( !document.all )
    {
        this.table.onselectstart = false;
    }
    
	this.lastClicked = null;
	
	this.processClick = function( e, clickedRow ) 
    {
        //var ctrlClick = this.isControl( e );
        var ctrlClick = true;
        //var shiftClick = this.isShift( e );
        var shiftClick = false;
	    	
        if ( shiftClick )
		{
            for ( var i=0; i < this.selected.length; i++ )
            {
                var cur = this.selected[i];
                this.unhighlight( cur );
            }

            var start;
			if ( this.lastClicked != null )
			{
			    start = this.lastClicked;
			}
			else
			{
				start = clickedRow;
				this.lastClicked = clickedRow;
			}
			var startIndex = ( start.rowIndex < clickedRow.rowIndex ? start.rowIndex : clickedRow.rowIndex );
			var endIndex = ( start.rowIndex > clickedRow.rowIndex ? start.rowIndex : clickedRow.rowIndex );
			this.selected = new Array(0);
            var rows = this.table.getElementsByTagName( "tr" );
			
			for ( var i = startIndex; i <= endIndex; i++ )
		    {	
                this.selected[this.selected.length] = rows.item(i);
				this.highlight( rows.item(i) );
			}			
		}
		else if ( ctrlClick )
        {
            this.lastClicked = clickedRow;
			if ( this.isSelected( clickedRow ) )
            {
                this.unhighlight( clickedRow );
                this.selected = this.remove( this.selected, clickedRow );
            }
            else
            {
                this.selected[this.selected.length] = clickedRow;
                this.highlight( clickedRow );
            }
        }
        else
        {
		    this.lastClicked = clickedRow;
            for ( var i=0; i < this.selected.length; i++ )
            {
                var cur = this.selected[i];
                this.unhighlight( cur );
            }
			 
            this.selected = new Array( 1 );
            this.selected [0] = clickedRow;
            this.highlight( clickedRow );
        }
		
		this.selectionListener( this );
    }

    this.selectRow = function( id )
    {
	    var row = document.all ? document.all[id] : document.getElementById( id );
        
        this.selected[this.selected.length] = row;
        this.highlight( row );
    }
    
	this.processDoubleClick = function()
    {
       this.doubleClickListener();        
    }
	
    this.doubleClickListener = function()
    {

    }

    
    this.preprocessSubmit = function( form )
    {
        for ( var i=0; i < this.selected.length; i++ )
        {
            var cur = this.selected[i];
            var input = document.createElement( 'input' );

	        if ( document.all )
            {
                input.type = "hidden";
                input.name = this.table.id + "[" + cur.id + "]";
                input.value = cur.id;
            }
            else
            {
                input.setAttribute( 'type', "hidden" );
                input.setAttribute( 'name', this.table.id + "[" + cur.id + "]" );
                input.setAttribute( 'value', cur.id );
            }

            form.appendChild( input );
        }
    }

    this.isSelected = function( object )
    {
        var found = false;
		
        for ( var i=0; i < this.selected.length && !found; i++ )
        {
            var cur = this.selected[i];
            found = ( cur == object );
        }
		
        return found;
    }

    // Listners that can be overridden
	this.selectionListener = new Function( "table", "" );

    // Helper Functions
    this.remove = function( array, object )
    {
        var result = new Array( array.length - 1 );
        var newIndex = 0;
		
        for ( var i=0; i < array.length; i++ )
        {
            if ( array[i] != object )
            {
                result[newIndex] = array[i];
                newIndex++;
            }
        }
		
        return result;
    }
    this.highlight = function( obj )
    {
    	if ( document.layers ) 
        {
            var lyr = document.layers[obj.id]
            lyr.document.bgColor = color
            lyr.document.color = "white";
        }
        else
        {
            obj.style.backgroundColor = color
            obj.style.color = "white";
        }
    }

    this.unhighlight = function( obj )
    {
        if ( document.layers ) 
        {
            var lyr = document.layers[obj.id]
            lyr.document.bgColor = "";
            lyr.document.color = "";
        }
        else
        {
            obj.style.backgroundColor = "";
            obj.style.color = "";
        }
    }

    this.isControl = function( e )
    {
        var nav4 = window.Event ? true : false;
        return (nav4 && (e.modifiers & Event.CONTROL_MASK)) || e.ctrlKey;
    }

    this.isShift = function( e )
    {
        var nav4 = window.Event ? true : false;
        return (nav4 && (e.modifiers & Event.SHIFT_MASK)) || e.shiftKey;
    }    
}
