<?php
    require_once( "../../../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "admin/auth.php" );
    
    $op = array_key_exists( 'edit_op', $_REQUEST )?$_REQUEST['edit_op']:null;

    if ( isset( $op ) && $op != "Ok" )
    {
        header( "Location: ../../index.php" );
        echo "\n";
        die();
    }
    
    $success = false;
    
    if ( array_key_exists( 'columns_edited', $_REQUEST ) )
    {
        $browser_columns = $_REQUEST['browser_columns'];
        $bc = implode( ",", $browser_columns );
        
        // Validation Here
        $valid = true; 
    
        if ( $valid )
        {
            require_once( "core/db/tables/SLConfigTable.php" );
            require_once( "core/db/db_init.php" );
            $table = new SLConfigTable( $db );
            
            $bc_opt = $table->getOption( SL_BROWSER_COLUMNS );
            $success = $bc_opt->setValue( $bc );
            $sl_config->setBrowserColumns( $bc_opt->getValue() );
        }
    }
    
    if ( $success )
    {
        header( "Location: ../../index.php" );
        echo "\n";
        die();
    }
    else
    {
        $selected_in = $sl_config->getBrowserColumns(); 
        $total = array( 
            "title" => "Title", 
            "artist" => "Artist", 
            "album" => "Album", 
            "track" => "Track", 
            "genre" => "Genre"
        );

        $available = array();
        $selected = array();

        foreach( $selected_in as $sel )
        {
            $selected[$sel] = $total[$sel];
        }
        
        foreach( array_keys( $total ) as $key )
        {
            if ( !array_key_exists( $key, $selected_in ) )
            {
                $available[$key] = $total[$key];
            }   
        }

        //$body_onload = "createListObjects()";
        //$javascripts = array( "option.js" );
        $sl_admin_title = "Browser Display Setup";
        $sl_admin_nav_links = array( "Home" => "../../index.php", "Browser Display Setup" => "" );
        
        require_once( "core/theme/SLPageInfo.php" );
        $sl_page_info = &new SLPageInfo( SL_ADMIN_PAGE, "Streamline Administration", "Browser Display Setup", "createListObjects()" );
        require( "core/theme/includes/admin_header.php" );
?>
    
    <script language="javascript" type="text/javascript" src="option.js" ></script>
      <p>
        This option determines the columns which are displayed in the browser.
      </p>
    <form id="browser_columns" action="browser.php" method="get" onSubmit="preProcessSubmit( this )">
      <input type="hidden" name="columns_edited" value="true">
      <table border="0" width="400" bgcolor="#CCCCCC" style="border: solid 1px black">
        <tr>
           <td align="center"><strong>Available Attributes</strong></td>
           <td></td>
           <td align="center"><strong>Selected Attributes</strong></td>
           <td></td>
        </tr>
        <tr>
          <td>
            <select style="height: 200px; width: 200px;" onClick="deselectSelectedList()" size=2 id="availableOptions" name="availableOptions" onChange="updateButtonState()">
              <?php
                foreach( array_keys( $available ) as $key )
                {
                    $value = $available[$key];
                    echo "<option value='$key'>$value</option>\n";
                }
              ?>
            </select>
          </td>
          <td valign="middle" align="center" >
            <input type="button" onclick="addAttribute()" id="add_button" value="Add"> 
            <br>
            <input type="button" onclick="delAttribute()" id="remove_button" value="Remove"> 
          </td>
          <td>
            <select size="4" onClick="deselectAvailableList()" style="height: 200px; width: 200px;" id="selectedOptions" name="selectedOptions" onChange="updateButtonState()">
              <?php
                foreach( array_keys( $selected ) as $key )
                {
                    $value = $selected[$key];
                    echo "<option value='$key'>$value</option>\n";
                }
              ?>
            </select>
          </td>
          <td valign="middle" align="center">
            <input type="button" onclick="moveUp()" id="up_button" value="Up"><br>
            <input type="button" onclick="moveDown()" id="down_button" value="Down">
          </td>
        </tr>
        <tr>
          <td colspan="4">
            <hr>
          </td>
        </tr>
        <tr>
          <td colspan="4" align="right">
            <input type="submit" name="edit_op" value="Cancel">
            <input type="submit" name="edit_op" value="Ok">
          </td>
          <td>
          </td>
        </tr>
      </table>
    </form>
<?php
        require_once( "core/theme/includes/admin_footer.php" );
    }
?>
