<?php
    require_once( "../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "core/db/db_init.php" );
    require_once( "core/db/util/SLQuickStats.php" );
    require_once( "core/sl_version.php" );
    require_once( "admin/auth.php" );
    
    
    require_once( "core/theme/SLPageInfo.php" );
    $sl_page_info = &new SLPageInfo( 
        SL_ADMIN_PAGE, 
        "Streamline Administration", 
        "Streamline Media Server Administration", 
        "" );
    
    $qs = new SLQuickStats( $db );
    require_once( "core/theme/includes/admin_header.php" );
?>
          <!-- Start Admin Body -->
          <table width="100%" cellpadding="0" cellspacing="0" border="0">
            <tr>
              <td width="1%" valign="top">
                <table class="admin_section" cellpadding="0" cellspacing="0">
                  <tr>
                    <td class="admin_section_header">Server Information</td>
                  </tr>
                  <tr>
                    <td>
                      <table>
                        <tr>
                          <td width="1%" nowrap="nowrap" class="infolabel">Server Name: </td>
                          <td width="99%" nowrap="nowrap" class="infovalue"><?php echo $sl_config->getServerTitle(); ?></td>
                        </tr>
                        <tr>
                          <td width="1%" nowrap="nowrap" class="infolabel">Version: </td>
                          <td width="99%" nowrap="nowrap" class="infovalue"><?php echo "$sl_version_number-$sl_version_suffix"; ?></td>
                        </tr>
                        <tr>
                          <td width="1%" nowrap="nowrap" class="infolabel">Host Name: </td>
                          <td width="99%" nowrap="nowrap" class="infovalue"><?php echo $_SERVER['SERVER_NAME']; ?></td>
                        </tr>
                        <tr>
                          <td width="1%" nowrap="nowrap" class="infolabel">IP Address: </td>
                          <td width="99%" nowrap="nowrap" class="infovalue"><?php echo $_SERVER['SERVER_ADDR']; ?></td>
                        </tr>
                        <tr>
                          <td width="1%" nowrap="nowrap" class="infolabel">Location: </td>
                          <td width="99%" nowrap="nowrap" class="infovalue"><?php echo $sl_config->getMediaServerRoot(); ?></td>
                        </tr>
                        <tr>
                          <td width="1%" nowrap="nowrap" class="infolabel">Media Library: </td>
                          <td width="99%" nowrap="nowrap" class="infovalue"><?php echo $sl_config->getMediaRoot(); ?></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                </table>
                <br>
                <table class="admin_section" width="100%" cellpadding="0" cellspacing="0">
                  <tr>
                    <td class="admin_section_header">Database Information</td>
                  </tr>
                  <tr>
                    <td>
                      <table width="100%">
                        <tr>
                          <td width="1%" nowrap="nowrap" class="infolabel">Databse Type: </td>
                          <td width="99%" nowrap="nowrap" class="infovalue"><?php echo $sl_db_type; ?></td>
                        </tr>
                        <tr>
                          <td width="1%" nowrap="nowrap" class="infolabel">Databse Host: </td>
                          <td width="99%" nowrap="nowrap" class="infovalue"><?php echo $sl_db_host; ?></td>
                        </tr>
                        <tr>
                          <td width="1%" nowrap="nowrap" class="infolabel">Database Name: </td>
                          <td width="99%" nowrap="nowrap" class="infovalue"><?php echo $sl_db_name; ?></td>
                        </tr>
                        <tr>
                          <td width="1%" nowrap="nowrap" class="infolabel">Database User: </td>
                          <td width="99%" nowrap="nowrap" class="infovalue"><?php echo $sl_db_user; ?></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                </table>
                <br>
                <table width="100%" class="admin_section" cellpadding="0" cellspacing="0">
                  <tr>
                    <td class="admin_section_header">Quick Stats</td>
                  </tr>
                  <tr>
                    <td>
                      <table width="100%">
                        <tr>
                          <td width="1%" nowrap="nowrap" class="infolabel">System Users: </td>
                          <td width="99%" nowrap="nowrap" class="infovalue"><?php echo number_format( $qs->getNumUsers() ); ?></td>
                        </tr>
                        <tr>
                          <td width="1%" nowrap="nowrap" class="infolabel">Indexed Media Files: </td>
                          <td width="99%" nowrap="nowrap" class="infovalue"><?php echo number_format( $qs->getNumMedia() ); ?></td>
                        </tr>
                        <tr>
                          <td width="1%" nowrap="nowrap" class="infolabel">Streams Today: </td>
                          <td width="99%" nowrap="nowrap" class="infovalue"><?php echo number_format( $qs->getNumStreams() ); ?></td>
                        </tr>
                        <tr>
                          <td width="1%" nowrap="nowrap" class="infolabel">Browses Today: </td>
                          <td width="99%" nowrap="nowrap" class="infovalue"><?php echo number_format( $qs->getNumBrowses() ); ?></td>
                        </tr>
                        <tr>
                          <td width="1%" nowrap="nowrap" class="infolabel">Downloads Today: </td>
                          <td width="99%" nowrap="nowrap" class="infovalue"><?php echo number_format( $qs->getNumDownloads() ); ?></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                </table>
                <br>
                <strong>
                  <a class="admin_link" href="<?php echo $_SESSION[SL_BROWSER_URI]; ?>">Back to the Server</a>
                </strong>
              </td>
              <td style="padding-left: 20px" width="99%" valign="top">
                <table width="100%" cellpadding="0" cellspacing="0">
                  <tr>
                    <td valign="top">
                      <table class="admin_section" width="100%" cellspacing="0" cellpadding="0">
                        <tr>
                          <td class="admin_section_header" colspan="4">Server Management</td>
                        </tr>
                        <tr>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="users/index.php" class="admin_link"><img border="0" src="images/users.png" alt=""><BR>Manage Users</a></td>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="config/access_control/user_privileges.php" class="admin_link"><img border="0" src="images/authentication.png" alt=""><BR>User Priveleges</a></td>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="config/access_control/host_access.php" class="admin_link"><img border="0" src="images/host_access.png" alt=""><BR>Host Access Control</a></td>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="config/access_control/agent_access.php" class="admin_link"><img border="0" src="images/agent_access.gif" alt=""><BR>Agent Access Control</a></td>
                        </tr>
                        <tr>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="config/locations.php" class="admin_link"><img border="0" src="images/locations.gif" alt=""><BR>Locations</a></td>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="config/logs.php" class="admin_link"><img border="0" src="images/log_setup.png" alt=""><BR>Logging Set Up</a></td>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="config/media_types/index.php" class="admin_link"><img border="0" src="images/media_types.png" alt=""><BR>Media Types</a></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td valign="top" style="padding-top: 20px">
                      <table class="admin_section" width="100%" cellspacing="0" cellpadding="0">
                        <tr>
                          <td class="admin_section_header" colspan="4">Presentation</td>
                        </tr>
                        <tr>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="config/presentation/title.php" class="admin_link"><img border="0" src="images/title.gif" alt=""><BR>Server Title</a></td>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="config/presentation/theme.php" class="admin_link"><img border="0" src="images/theme.gif" alt=""><BR>Theme Chooser</a></td>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="config/presentation/browser.php" class="admin_link"><img border="0" src="images/browser.gif" alt=""><BR>Browser Config</a></td>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="config/presentation/sort_order.php" class="admin_link"><img border="0" src="images/sort_order.png" alt=""><BR>Sort Order</a></td>
                        </tr>
                        <tr>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="config/presentation/stream_format.php" class="admin_link"><img border="0" src="images/stream_format.gif" alt=""><BR>Stream Format</a></td>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td valign="top" style="padding-top: 20px">
                      <table class="admin_section" width="100%" cellspacing="0" cellpadding="0">
                        <tr>
                          <td class="admin_section_header" colspan="4">Logs and Statistics</td>
                        </tr>
                        <tr>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="logs/browse_log.php" class="admin_link"><img border="0" src="images/browse_log.png" alt=""><BR>Browse Log</a></td>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="logs/stream_log.php" class="admin_link"><img border="0" src="images/stream_log.png" alt=""><BR>Stream Log</a></td>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="logs/download_log.php" class="admin_link"><img border="0" src="images/download_log.png" alt=""><BR>Download Log</a></td>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="logs/error_log.php" class="admin_link"><img border="0" src="images/error_log.png" alt=""><BR>Error Log</a></td>
                        </tr>
                        <tr>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="stats/index.php" class="admin_link"><img border="0" src="images/stats.png" alt=""><BR>Statistics</a></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td valign="top" style="padding-top: 20px">
                      <table class="admin_section" width="100%" cellspacing="0" cellpadding="0">
                        <tr>
                          <td class="admin_section_header" colspan="4">Server Maintenance</td>
                        </tr>
                        <tr>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="maintenance/media_cache.php" class="admin_link"><img border="0" src="images/media_cache.png" alt=""><BR>Update Media Info Cache</a></td>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="maintenance/media_db.php" class="admin_link"><img border="0" src="images/media_database.png" alt=""><BR>Update Media DB</a></td>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="maintenance/batch.php" class="admin_link"><img border="0" src="images/batch.png" alt=""><BR>Batch Update</a></td>
                          <td valign="top" style="padding: 5px;" width="25%" align="center"><a href="maintenance/clean_db.php" class="admin_link"><img border="0" src="images/clean_database.png" alt=""><BR>Clean Database</a></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                </table>
              </td>
            </tr>
          </table>
          <!-- End Admin Body -->
<?php
    require_once( "core/theme/includes/admin_footer.php" );
?>
