<?
    require_once( "../../sl_root.php" );
    require_once( "core/db/db_init.php" );
    
    $log_type = isset( $_REQUEST['log_type'] )?$_REQUEST['log_type']:"stream";
    
    switch( $log_type )
    {
        case "browse":
            require_once( "core/db/tables/SLBrowseLogTable.php" );
            $table = &new SLBrowseLogTable( $db );
            break;

        case "stream":
            require_once( "core/db/tables/SLStreamLogTable.php" );
            $table = &new SLStreamLogTable( $db );
            break;

        case "download":
            require_once( "core/db/tables/SLDownloadLogTable.php" );
            $table = &new SLDownloadLogTable( $db );
            break;

        case "error":
            require_once( "core/db/tables/SLErrorLogTable.php" );
            $table = &new SLErrorLogTable( $db );
            break;

    }
   
    if ( isset( $_REQUEST['action'] ) )
    {
        $action = $_REQUEST['action'];
        
        if( $action == "empty_table" )
        {
            $table->deleteAllEntries();
        }
        else if( $action == "truncate_table" )
        {
            $time_period = $_REQUEST['time_period'];
            
            $time_offset = 60*60*24;
            
            if ( $time_period == "week" )
            {
                $time_offset = $time_offset * 7;
            }
            else if ( $time_period == "month" )
            {
                $time_offset = $time_offset * 30;
            }

            $time = strtotime( date( "d F Y", time() ) ) - $time_offset; 

            $table->deleteEntriesOlderThanTime( $time );
        }
    }
    
    $number = $table->getNumberOfRows();
    
    $log_link_title = ucfirst( $log_type )." Log";
    $log_link = $log_type."_log.php";
    $sl_admin_nav_links = array( "Home" => "../index.php", $log_link_title => $log_link, "Manage ".$log_link_title => "" );
    $sl_admin_title = "Manage ".ucfirst( $log_type )." Log";
    require_once( "../admin.header.php" );
?>
        <p>The <?php echo ucfirst( $log_type ); ?> Log currently has <?php echo $number; ?> Entries.
        
        <form action="manage_log.php">
          <input type="hidden" name="action" value="empty_table">
          <input type="hidden" name="log_type" value="<?php echo $log_type ?>">
          <table>
            <tr>
              <td>Clear <?php echo ucfirst( $log_type ); ?> Log: </td>
              <td><input type="submit" name="submit" value="Go"></td>
            <tr>
          </table>
        </form>
        <form action="manage_log.php">
          <input type="hidden" name="action" value="truncate_table">
          <input type="hidden" name="log_type" value="<?php echo $log_type ?>">
          <table>
            <tr>
              <td>Clear Log Entries Older than: </td>
              <td>
                <select name="time_period">
                  <option value="day">1 Day</option>
                  <option value="week">7 Days</option>
                  <option value="month">30 Days</option>
                </select>
              </td>
              <td><input type="submit" name="submit" value="Go"></td>
            <tr>
          </table>
        </form>
<?
    require_once( "../admin.footer.php" );
?>
