<?php
    require( "../../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "admin/auth.php" );
    require_once( "core/indexing/MediaDBMaintainer.php" );
    require_once( "core/indexing/MediaInfoCacheMaintainer.php" );
    
    
    require_once( "core/theme/SLPageInfo.php" );
    $sl_page_info = &new SLPageInfo( 
        SL_ADMIN_PAGE, 
        "Streamline Administration", 
        "Streamline Maintenance", 
        "" );
    
    require_once( "core/theme/includes/admin_header.php" );
    flush();

    $mdbm = new MediaDBMaintainer( $db, $sl_config->getMediaRoot() );
    
    echo "<br><h3>Updating Media Database and Media Info Cache...</h3>";
    flush();
    $mdbm->update();
    echo "<h3>Media Database and Media Info Cache Update Complete</h3>";
    echo "<h3>Pruning Media Database and Media Info Cache...</h3>";
    flush();
    $mdbm->prune();

    $icm = new MediaInfoCacheMaintainer( $sl_config->getMediaRoot() );
    flush();
    $icm->prune();
    echo "Media Database and Media Info Cache Pruning Complete<br>";
?>
   <br>
   <br>
   <button onClick="window.close()">Done</button> 
<?php
    require_once( "core/theme/includes/admin_footer.php" );
?>
