<?php
    require( "../../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "admin/auth.php" );
    require( "core/db/util/SLDBMaintainer.php" );
    
    
    require_once( "core/theme/SLPageInfo.php" );
    $sl_page_info = &new SLPageInfo( 
        SL_ADMIN_PAGE, 
        "Streamline Administration", 
        "Streamline Maintenance", 
        "" );
    
    require_once( "core/theme/includes/admin_header.php" );
    flush();

    $truncate_logs = isset( $_REQUEST['truncate_logs'] )?$_REQUEST['truncate_logs']=="on":false;
    $truncate_stats = isset( $_REQUEST['truncate_stats'] )?$_REQUEST['truncate_stats']=="on":false;
    $non_user_artifacts = isset( $_REQUEST['non_user_artifacts'] )?$_REQUEST['non_user_artifacts']=="on":false;

    $maintainer = &new SLDBMaintainer( $db );

    if ( $truncate_logs )
    {
        $time_period = $_REQUEST['log_time_period'];
        
        $time_offset = 60*60*24;
        
        if ( $time_period == "week" )
        {
            $time_offset = $time_offset * 7;
        }
        else if ( $time_period == "month" )
        {
            $time_offset = $time_offset * 30;
        }

        $time = strtotime( date( "d F Y", time() ) ) - $time_offset;

        echo "Removing log entries older than '".date( "d F Y", $time )."'....";
        $maintainer->truncateLogs($time);
        echo "Done<br>";
    }
    if ( $truncate_stats )
    {
        $time_period = $_REQUEST['stats_time_period'];
        
        $time_offset = 60*60*24;
        
        if ( $time_period == "week" )
        {
            $time_offset = $time_offset * 7;
        }
        else if ( $time_period == "month" )
        {
            $time_offset = $time_offset * 30;
        }

        $time = strtotime( date( "d F Y", time() ) ) - $time_offset;

        echo "Removing stats older than '".date( "d F Y", $time )."'....";
        $maintainer->truncateStats($time);
        echo "Done<br>";
    }

    if ( $non_user_artifacts )
    {
        echo "Removing Artifacts for users that no longer exists....";
        $maintainer->removeDeletedUserArtifacts();
        echo "Done<br>";
    }

?>
   <br>
   <br>
   <a class="admin_link" href="../index.php">Back to Admin Home</a>
<?php
    require_once( "core/theme/includes/admin_footer.php" );
?>
