<?php
    require_once( "../../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "admin/auth.php" );

    require_once( "core/db/db_init.php" );
    require_once( "core/stats/SLDailyStatsEngine.php" );
    require_once( "core/stats/SLMediaStatsEngine.php" );
    require_once( "core/stats/SLUserStatsEngine.php" );
    require_once( "core/db/tables/SLUserTable.php" );
    require_once( "core/media_info/MediaInfoCache.php" );

    
    // MEDIA STATISTICS 
    $media_stats_engine = &new SLMediaStatsEngine( $db );
    $media_by_streams = $media_stats_engine->getTopMediaRankedByStreams( 10 );
    $media_by_downloads = $media_stats_engine->getTopMediaRankedByDownloads( 10 );
    
    // USER STATISTICS
    $user_stats_engine = &new SLUserStatsEngine( $db );
    $user_table = new SLUserTable( $db );
    
    $uids_by_streams = $user_stats_engine->getTopUsersRankedByStreams( 5 );
    $keys = array_keys( $uids_by_streams );
    $users_by_streams = array();
   
    foreach( $keys as $key )
    {
        $user = $user_table->getUserById( $key );
        $users_by_streams[$user->getUserName()] = $uids_by_streams[$key];
    }

    $uids_by_downloads = $user_stats_engine->getTopUsersRankedByDownloads( 5 );
    $keys = array_keys( $uids_by_downloads );
    $users_by_downloads = array();
   
    foreach( $keys as $key )
    {
        $user = $user_table->getUserById( $key );
        $users_by_downloads[$user->getUserName()] = $uids_by_downloads[$key];
    }
    
    $sl_admin_nav_links = array( "Home" => "../index.php", "Server Statistics" => "" );

    require_once( "core/theme/SLPageInfo.php" );
    $sl_page_info = &new SLPageInfo( 
        SL_ADMIN_PAGE, 
        "Streamline Administration", 
        "Server Statistics", 
        "" );

    require_once( "core/theme/includes/admin_header.php" );
?>
          <!-- Start Admin Body -->
          <h3 style="padding-top: 10px">Service Usage Statistics</h3>
          <table>
            <tr>
              <td style="padding-right: 15px">
                <table cellspacing="0" cellpadding="0" style="border: 1px solid black">
                  <tr>
                    <td>
                      <a href="advanced_service_graph.php?service=browse"><img border=0 src="service_stats_graph.php?service=browse&amp;width=250&amp;height=125"></a>
                    </td>
                  </tr>
                </table>
              </td>
              <td style="padding-right: 15px">
                <table cellspacing="0" cellpadding="0" style="border: 1px solid black">
                  <tr>
                    <td>
                      <a href="advanced_service_graph.php?service=stream"><img border=0 src="service_stats_graph.php?service=stream&amp;width=250&amp;height=125"></a>
                    </td>
                  </tr>
                </table>
              </td>
              <td>
                <table cellspacing="0" cellpadding="0" style="border: 1px solid black">
                  <tr>
                    <td>
                      <a href="advanced_service_graph.php?service=download"><img border=0 src="service_stats_graph.php?service=download&amp;width=250&amp;height=125"></a>
                    </td>
                  </tr>
                </table>
              </td>
            </tr>
            <tr>
              <td align="center" style="font-size: 80%">Click For More Options</td>
              <td align="center" style="font-size: 80%">Click For More Options</td>
              <td align="center" style="font-size: 80%">Click For More Options</td>
            </tr>
          </table>
          <!-- MEDIA STATISTICS -->
          <h3 style="padding-top: 10px">Media Statistics</h3>
          <table>
            <tr>
              <td style="padding-right: 10px">
                <strong>Top Media By # of Streams:</strong>
                <div style="padding: 20px">
                <table style="border: 1px solid black; width: 100%">
                  <tr>
                    <td>
                      <table style="width: 100%">
                        <tr>
                          <td bgcolor="#DDDDDD" style="padding-right: 5px; padding-left: 5px"><strong>Rank</strong></td>
                          <td bgcolor="#DDDDDD" style="padding-right: 5px; padding-left: 5px"><strong>User Name</strong></td>
                          <td bgcolor="#DDDDDD" style="padding-right: 5px; padding-left: 5px"><strong>#</strong></td>
                        <?php
                          $rank = 1;
                          $paths = array_keys( $media_by_streams );
                          foreach( $paths as $path )
                          {
                              $streams = $media_by_streams[$path];
                        ?>      
                        <tr>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"><?php echo $rank;?>.</td>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"><?php echo $path;?></td>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"><?php echo $streams;?></td>
                        </tr>
                        <?php
                              $rank++;
                          }

                          for ( $rank; $rank <= 10; $rank++ )
                          {
                        ?>
                        <tr>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"><?php echo $rank;?>.</td>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"> </td>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"> </td>
                        </tr>
                        <?
                          }
                        ?>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td style="border-top: 1px solid black" align="right"><a href="media_stats.php?stat=streams">more &gt;&gt;</a></td>
                  </tr>
                </table>
                </div>
              </td>
            </tr>
            <tr>
              <td>
                <strong>Top Meida By # of Downloads:</strong>
                <div style="padding: 20px">
                <table style="border: 1px solid black; width: 100%">
                  <tr>
                    <td>
                      <table style="width: 100%">
                        <tr>
                          <td bgcolor="#DDDDDD" style="padding-right: 5px; padding-left: 5px"><strong>Rank</strong></td>
                          <td bgcolor="#DDDDDD" style="padding-right: 5px; padding-left: 5px"><strong>User Name</strong></td>
                          <td bgcolor="#DDDDDD" style="padding-right: 5px; padding-left: 5px"><strong>#</strong></td>
                        <?php
                          $rank = 1;
                          $paths = array_keys( $media_by_downloads );
                          foreach( $paths as $path )
                          {
                              $downloads = $media_by_downloads[$path];
                        ?>      
                        <tr>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"><?php echo $rank;?>.</td>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"><?php echo $path;?></td>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"><?php echo $downloads;?></td>
                        </tr>
                        <?php
                              $rank++;
                          }

                          for ( $rank; $rank <= 10; $rank++ )
                          {
                        ?>
                        <tr>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"><?php echo $rank;?>.</td>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"> </td>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"> </td>
                        </tr>
                        <?
                          }
                        ?>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td style="border-top: 1px solid black" align="right"><a href="media_stats.php?stat=downloads">more &gt;&gt;</a></td>
                  </tr>
                </table>
                </div>

              </td>
            </tr>
          </table>

          <!-- USER STATISTICS -->
          <h3 style="padding-top: 10px">User Statistics</h3>
          <table>
            <tr>
              <td style="padding-right: 10px">
                <strong>Top Users By # of Streams:</strong>
                <div style="padding: 20px">
                <table style="border: 1px solid black; width: 100%">
                  <tr>
                    <td>
                      <table style="width: 100%">
                        <tr>
                          <td bgcolor="#DDDDDD" style="padding-right: 5px; padding-left: 5px"><strong style="white-space: no-wrap">Rank</strong></td>
                          <td bgcolor="#DDDDDD" style="padding-right: 5px; padding-left: 5px"><strong style="white-space: no-wrap">User Name</strong></td>
                          <td bgcolor="#DDDDDD" style="padding-right: 5px; padding-left: 5px"><strong style="white-space: no-wrap">#</strong></td>
                        <?php
                          $rank = 1;
                          $names = array_keys( $users_by_streams );
                          foreach( $names as $name )
                          {
                              $streams = $users_by_streams[$name];
                        ?>      
                        <tr>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"><?php echo $rank;?>.</td>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"><?php echo $name;?></td>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"><?php echo $streams;?></td>
                        </tr>
                        <?php
                              $rank++;
                          }

                          for ( $rank; $rank <= 5; $rank++ )
                          {
                        ?>
                        <tr>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"><?php echo $rank;?>.</td>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"> </td>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"> </td>
                        </tr>
                        <?
                          }
                        ?>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td style="border-top: 1px solid black" align="right"><a href="user_stats.php?stat=streams">more &gt;&gt;</a></td>
                  </tr>
                </table>
                </div>
              </td>
              <td>
                <strong>Top Users By # of Downloads:</strong>
                <div style="padding: 20px">
                <table style="border: 1px solid black; width: 100%">
                  <tr>
                    <td>
                      <table style="width: 100%">
                        <tr>
                          <td bgcolor="#DDDDDD" style="padding-right: 5px; padding-left: 5px"><strong style="white-space: no-wrap">Rank</strong></td>
                          <td bgcolor="#DDDDDD" style="padding-right: 5px; padding-left: 5px"><strong style="white-space: no-wrap">User Name</strong></td>
                          <td bgcolor="#DDDDDD" style="padding-right: 5px; padding-left: 5px"><strong style="white-space: no-wrap">#</strong></td>
                        <?php
                          $rank = 1;
                          $names = array_keys( $users_by_downloads );
                          foreach( $names as $name )
                          {
                              $downloads = $users_by_downloads[$name];
                        ?>      
                        <tr>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"><?php echo $rank;?>.</td>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"><?php echo $name;?></td>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"><?php echo $downloads;?></td>
                        </tr>
                        <?php
                              $rank++;
                          }

                          for ( $rank; $rank <= 5; $rank++ )
                          {
                        ?>
                        <tr>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"><?php echo $rank;?>.</td>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"> </td>
                          <td bgcolor="#EEEEEE" style="padding-right: 5px; padding-left: 5px"> </td>
                        </tr>
                        <?
                          }
                        ?>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td style="border-top: 1px solid black" align="right"><a href="user_stats.php?stat=downloads">more &gt;&gt;</a></td>
                  </tr>
                </table>
                </div>

              </td>
            </tr>
          </table>
          <br><br>
          <a class="admin_link" href="../index.php">Back to Admin Home</a>
          <!-- End Admin Body -->
<?php
    require_once( "core/theme/includes/admin_footer.php" );
?>
