<?php
    require_once( "../../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "admin/auth.php" );

    $op = array_key_exists( 'operation', $_REQUEST )?$_REQUEST['operation']:null;

    if ( isset( $op ) && $op != "Ok" )
    {
        require_once( "view_user.php" );
        die();
    }
    
    require_once( "core/db/tables/SLUserTable.php" );
    require_once( "core/db/db_init.php" );
    
    $userid = array_key_exists( 'userid', $_REQUEST )?$_REQUEST['userid']:null;
  
    $table = new SLUserTable( $db );
    $user = $table->getUserById( $userid );

    $success = false;
    
    if ( isset( $_REQUEST['privs_edited'] ) )
    {
        $admin = isset( $_REQUEST['admin'] );
        $browse = isset( $_REQUEST['browse'] );
        $stream = isset( $_REQUEST['stream'] );
        $download = isset( $_REQUEST['download'] );
    
        // Validation Here
        $valid = true; 
    
        if ( $valid )
        {
            $user->setAdminFlag( $admin );
            $user->setBrowse( $browse );
            $user->setStream( $stream );
            $user->setDownload( $download );
            $success = $user->store();

            $sl_access_controler->evaluate( $db, $sl_config );

            if ( !$success )
            {
                $error =  "Could not store the user info because there was a database error.";
            }
        }
    }

    if ( $success )
    {
        require_once( "view_user.php" );
    }
    else
    {
        $admin = $user->getAdminFlag();
        $browse = $user->getBrowse();
        $stream = $user->getStream();
        $download = $user->getDownload();
        
        $user_name = $user->getUserName(); 

        require_once( "core/theme/SLPageInfo.php" );
        $sl_page_info = &new SLPageInfo( 
            SL_ADMIN_PAGE, 
            "Streamline Administration", 
            "Editing User Privileges for User '<i>$user_name</i>'", 
            "" );

        require( "core/theme/includes/admin_header.php" );
?>
          <!-- Start Admin Body -->
          <?php
            if ( isset( $error ) )
            {
                echo $error."<br>";
            }
          ?>
          <form action="edit_user_privs.php" method="post">
            <input type="hidden" name="userid" value="<?php echo $user->getUserId(); ?>">
            <input type="hidden" name="privs_edited" value="true">
            <table bgcolor="#CCCCCC" style="border: solid 1px black">
              <tr>
                <td><strong>Administrator: </strong></td>
                <td>
                  <input type="checkbox" name="admin" <?php echo $admin?'checked="checked"':''; ?>>
                </td>
              </tr>
              <tr>
                <td><strong>Browse: </strong></td>
                <td>
                  <input type="checkbox" name="browse" <?php echo $browse?'checked="checked"':''; ?>>
                </td>
              </tr>
              <tr>
                <td><strong>Stream: </strong></td>
                <td>
                  <input type="checkbox" name="stream" <?php echo $stream?'checked="checked"':''; ?>>
                </td>
              </tr>
              <tr>
                <td><strong>Download: </strong></td>
                <td>
                  <input type="checkbox" name="download" <?php echo $download?'checked="checked"':''; ?>>
                </td>
              </tr>
              <tr>
                <td align="right" colspan="2" style="border-top: solid 1px black; padding-top: 5px">
                  <input type="Submit" name="operation" value="Cancel">
                  <input type="Submit" name="operation" value="Ok">
                </td>
              </tr>
            </table>
          </form>
          <!-- End Admin Body -->
<?php
        require_once( "core/theme/includes/admin_footer.php" );
    }
?>
