<?
require_once( "streamline_functions.php" ); 

if ( !defined( "_MEDIA_SORTER" ) ){
      define( "_MEDIA_SORTER", 1 );    
     
     class MediaSorter
     {
        var $files;
        var $dir;
        var $sort_order;
        var $media_info_cache;
        
        function MediaSorter( $dir, $files, $sort_order, $media_info_cache )
        {
            $this->files = $files;
            $this->dir = $dir;
            $this->sort_order = $sort_order;
            $this->media_info_cache = $media_info_cache;
        }


        
        function quicksort()
        {
            if( count( $this->files )>1 )
            {
                $this->qsort( $this->files, 0, count( $this->files ) - 1 );
            }
            return $this->files;
        }

        function qsort($arr,$l,$r)
        {
            $l_hold = $l;
            $r_hold = $r;
            $pivot = $this->files[$l];

            while( $l < $r )
            {
                while(( $this->acmpb($this->files[$r],$pivot) >= 0 ) && ($l<$r) )
                {
                    $r--;
                }
                if( $l != $r )
                {
                    $this->files[$l] = $this->files[$r];
                    $l++;
                }
                while( ( $this->acmpb( $this->files[$l],$pivot ) <= 0 ) && ($l<$r))
                {
                    $l++;
                }
                if( $l != $r )
                {
                    $this->files[$r] = $this->files[$l];
                    $r--;
                }
            }

            $this->files[$l] = $pivot;
            $pivot = $l;
            $l = $l_hold;
            $r = $r_hold;
            if( $l < $pivot )
            {
                $this->qsort($this->files, $l, $pivot-1);
            }
            if($r > $pivot )
            {
                $this->qsort($this->files, $pivot+1, $r );
            }
        }
        
        function bubbles()
        {
            $c = count( $this->files ) - 1;
    
            //bubble sort...do somehting better.
            
            for( $i = 0; $i < $c; $i++ )
            {
                for( $j = 0; $j < ($c - $i); $j++ )
                {
                    set_time_limit( 30 );
                    
                    if ( $this->aGreaterThanB( $this->files[$j], $this->files[$j+1] ) )
                    {
                        $temp = $this->files[$j];
                        $this->files[$j] = $this->files[$j+1];
                        $this->files[$j+1] = $temp;
                    }
                }
            }

            return $this->files;
        }
            
        function acmpb( $file_a, $file_b )
        {
            if ($file_a == $file_b) 
            {
                return 0;
            }
            
            $result = 0;
            $done = false;
            $info_a = $this->media_info_cache->getMediaInfo( joinFilePath( $this->dir, $file_a ) );
            $info_b = $this->media_info_cache->getMediaInfo( joinFilePath( $this->dir, $file_b ) );
            
            foreach( $this->sort_order as $s )
            {
                switch ( $s )
                {
                    case "ARTIST":
                        $cmp = strcmp($info_a->getArtist(), $info_b->getArtist() ); 
                        if ( $cmp != 0 )
                        {
                            $done = true;
                        }
                        break;
                    
                    case "ALBUM":
                        $cmp = strcmp($info_a->getAlbum(), $info_b->getAlbum() ); 
                        if ( $cmp != 0 )
                        {
                            $done = true;
                        }
                        break;
                    
                    case "TRACK":
                        $track_a = intval( $info_a->getTrack() );
                        $track_b = intval( $info_b->getTrack() );
                        
                        if ( $track_a == $track_b )
                        {
                            $cmp = 0;
                        }
                        else
                        {
                            $cmp = ( $track_a  < $track_b )?-1:1;
                            $done = true;
                        }
                         
                        break;
                    
                    case "TITLE":
                        $cmp = strcmp($info_a->getTitle(), $info_b->getTitle() ); 
                        if ( $cmp != 0 )
                        {
                            $done = true;
                        }
                        break;
                    case "GENRE":
                        $cmp = strcmp($info_a->getGenre(), $info_b->getGenre() ); 
                        if ( $cmp != 0 )
                        {
                            $done = true;
                        }
                        break;
                
                }

                if ( $done )
                {
                    break;
                }
            }
            
            return $cmp;
        }

        function aGreaterThanB( $file_a, $file_b )
        {
            if ($file_a == $file_b) 
            {
                return 0;
            }
            
            $result = 0;
            $done = false;
            $info_a = $this->media_info_cache->getMediaInfo( joinFilePath( $this->dir, $file_a ) );
            $info_b = $this->media_info_cache->getMediaInfo( joinFilePath( $this->dir, $file_b ) );
            
            foreach( $this->sort_order as $s )
            {
                switch ( $s )
                {
                    case "ARTIST":
                        $cmp = strcmp($info_a->getArtist(), $info_b->getArtist() ); 
                        if ( $cmp != 0 )
                        {
                            $done = true;
                        }
                        break;
                    
                    case "ALBUM":
                        $cmp = strcmp($info_a->getAlbum(), $info_b->getAlbum() ); 
                        if ( $cmp != 0 )
                        {
                            $done = true;
                        }
                        break;
                    
                    case "TRACK":
                        $track_a = intval( $info_a->getTrack() );
                        $track_b = intval( $info_b->getTrack() );
                        
                        if ( $track_a == $track_b )
                        {
                            $cmp = 0;
                        }
                        else
                        {
                            $cmp = ( $track_a  < $track_b )?-1:1;
                            $done = true;
                        }
                         
                        break;
                    
                    case "TITLE":
                        $cmp = strcmp($info_a->getTitle(), $info_b->getTitle() ); 
                        if ( $cmp != 0 )
                        {
                            $done = true;
                        }
                        break;
                    case "GENRE":
                        $cmp = strcmp($info_a->getGenre(), $info_b->getGenre() ); 
                        if ( $cmp != 0 )
                        {
                            $done = true;
                        }
                        break;
                
                }

                if ( $done )
                {
                    break;
                }
            }
            
            return $cmp > 0;
        }


        function sortMedia()
        {
                // Currently, there are 2 sorts implemented: 
                // Quicksort and bubble sort.  If for some 
                // reason you feel like using bubblesort, just
                // uncomment the line that calls bubbles,
                // and comment out the quicksort line.
                // Bubblesort- just here for posterity

                //return $this->bubbles();
                return $this->quicksort();
        }

    }
}
?>
