<?php
require_once( "core/streamline_functions.php" );
require_once( "core/browser/SLMediaTableGen.php" );
require_once( "core/browser/SLDirTableGen.php" );
require_once( "core/ui/nav/SLLink.php" );

if ( !defined( "_SL_BROWSER" ) ){
      define( "_SL_BROWSER", 1 );
   
    
        
    class SLBrowser
    {
        var $dir;
        var $media_server_root;
        var $browse_root;
        var $path;
        var $parent_path;
        var $up_path;
        var $theme_path;
        var $web_server_root;
        var $browser_columns;
        var $sort_order;
        var $show_play;
        var $dir_explorer;
        var $access_controler;

        
        function SLBrowser( &$dir_explorer, &$sl_config, &$access_controler )
        {
            $this->media_server_root = $sl_config->getMediaServerRoot();
            $this->browse_root = joinURLPath( $this->media_server_root, "browse");

            $this->dir_explorer = &$dir_explorer;
            $this->dir = $dir_explorer->getDir();

            $this->access_controler = &$access_controler;

            $this->path = split( "/", $this->dir );
            $this->parent_path = split( "/", $this->dir );
            array_pop( $this->parent_path );
            array_pop( $this->parent_path );
            $this->up_path = join( "/", $this->parent_path );
            $this->up_path = $this->up_path."/";

            $this->theme_path = "themes/".$sl_config->getTheme();
            $this->web_server_root = $sl_config->getWebServerRoot();
            $this->browser_columns = $sl_config->getBrowserColumns();
            $this->sort_order = $sl_config->getSortOrder();

            $this->show_play = $access_controler->getStreamAccess();
        }



        function getBreadCrums()
        {
            $result = array();
            $result[] = new SLLink( $this->browse_root, "Home", "Home", "sl_bread_crum_link" );
                         
            $link_path = "";
    
            foreach( $this->path as $cur_path )
            {
                if( $cur_path != "" )
                {
                    if ( $link_path == "" )
                    {
                        $link_path = $cur_path;
                    }
                    else
                    {
                        $link_path = joinURLPath( $link_path, $cur_path );
                    }
                    
                    $result[] = new SLLink( 
                        joinURLPath( $this->browse_root, htmlspecialchars( $link_path ) ), 
                        htmlspecialchars( $cur_path ), htmlspecialchars( $cur_path ), "sl_bread_crum_link" );
                }
            }

            return $result;
        }

        function showParentLink()
        {
        
            return $this->dir != "/" && $this->dir != "";
        }

        function getParentLink()
        {
            return new SLLink( 
                joinURLPath( $this->browse_root, htmlspecialchars( $this->up_path ) ), 
                "Parent Directory",
                "Parent Directory",
                "sl_bread_crum_link" );
        }
        
        function showPlayLink()
        {
            return $this->show_play;
        }

        function getPlayLink()
        {
            return new SLLink( 
                joinURLPath( htmlspecialchars( joinURLPath( joinURLPath( $this->media_server_root, "m3u" ), $this->dir ) ), "play_all.m3u" ), 
                "Play",
                "Play",
                "sl_bread_crum_link" );
        }

        function hasFiles()
        {
            return $this->dir_explorer->getNumFiles() > 0;
        }
        
        function outputFilesBrowser()
        {
            $table_gen = new SLMediaTableGen( 
                $this->dir_explorer->getFiles(), 
                $this->browser_columns, 
                $this->media_server_root,
                $this->access_controler );

            $table_gen->generateTable( "" );
        }
        
        function hasDirs()
        {
            return $this->dir_explorer->getNumDirs() > 0;
        }
        
        function outputDirsBrowser()
        {
            $table_gen = new SLDirTableGen( $this->dir_explorer->getDirs(), $this->media_server_root, $this->access_controler); 
            $table_gen->generateTable( "" );
        }
    }
}
?>
