<?php
require_once( "core/streamline_functions.php" );

if ( !defined( "_SL_DIR_TABLE_GEN" ) ){
      define( "_SL_DIR_TABLE_GEN", 1 );

    class SLDirTableGen
    {
        var $dirs;
        var $media_server_root;
        var $baseuri;
        var $stream_access;
        var $theme_path;
        
        function SLDirTableGen( &$dirs, $media_server_root, &$access_controler )
        {
            $this->dirs = &$dirs;
            $this->media_server_root = $media_server_root;
            $browse_root = joinURLPath( $media_server_root, "browse" );
            $mrl = strlen( $browse_root );
            $baseuri = $_SERVER["REQUEST_URI"];
            $baseuri = substr( $baseuri, $mrl, strlen( $baseuri ) - $mrl );
            $this->baseuri = $baseuri;
            $this->stream_access = $access_controler->getStreamAccess();
            global $sl_cur_theme;
            $this->theme_path = $sl_cur_theme->getWebPath();
        }

        function generateTable( $title )
        {
            $this->startTable( $title );
            $this->outputTableHeader();
            $this->outputTableBody();
            $this->endTable();
        }
        
        function startTable( $title )
        {
            outputHTMLLine( "<table class=\"sl_browser_table\">" );
        }
        
        function outputTableHeader()
        {

            outputHTMLLine( "<tr>" );
            outputHTMLLine( "<th class=\"sl_browser_header\">Directory</th>" );
            
            if ( $this->stream_access )
            {
                outputHTMLLine( "<th class=\"sl_browser_header\" colspan=\"2\">Actions</th>" );
            }
            
            outputHTMLLine( "</tr>" );
        }

        function outputTableBody()
        {
            $images_path = joinURLPath( $this->theme_path, "images" );

            $row_count = 0;

            foreach ( $this->dirs as $dir )
            {
                $row_count++;
                
                $media_server_root = $this->media_server_root;
                $path = joinURLPath( $this->baseuri, $dir );

                if ( $row_count % 2 != 0 )
                {
                    outputHTMLLine( "<tr class=\"sl_browser_even_row\">" );
                }
                else
                {
                    outputHTMLLine( "<tr class=\"sl_browser_odd_row\">" );
                }

                outputHTMLLine( "<td class='sl_browser_dir' style=\"padding-left: 5px\" align=\"left\">" );
                outputHTMLLine( "<a class='sl_browser_dir_link' title=\"View '".htmlspecialchars($dir).
                    "'\" href=\"".rawurlencode( $dir )."/\">".htmlspecialchars($dir)."</a>" );
                outputHTMLLine( "</td>" );
               
                
                if ( $this->stream_access )
                {
                    // Stream Link
                    $s_link = htmlspecialchars( joinURLPath( joinURLPath( $media_server_root, "m3u" ), $path ) );
                    outputHTMLLine( 
                        "<td width=\"1%\" class='sl_browser_action'><a class='sl_browser_action_link' title=\"Stream '".
                        htmlspecialchars($dir)."' \"href=\"$s_link/play_all.m3u\"><img border=0 src=\"$images_path/stream.png\" alt=\"Stream\"></a></td>" );
                    
                    // Playlist Link
                    outputHTMLLine( "<td width=\"1%\" class='sl_browser_action'>".
                        "<a title=\"Add '".htmlspecialchars( $dir )."' to Current Playlist\" href=\"#\"><img onClick=\"AddWindow=window.open('$media_server_root/home/playlists/add_dir.php?path=".rawurlencode( $path ).
                        "&amp;dirname=".rawurlencode( $dir )."','AddToPlayList',".
                        "'toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=yes,width=350,height=150'); AddWindow.focus(); return false;\" ".
                        "border=0 src=\"$images_path/playlist_add.png\" alt=\"Playlist Add\"></a></td>" );
                }
                
                outputHTMLLine( "</tr>" );
                
            }
        
        }

        function endTable()
        {
            outputHTMLLine( "</table>" );
        }
    }
}
?>
