<?php
if ( !defined( "_SL_DATA_BASE" ) ){
      define( "_SL_DATA_BASE", 1 );
      
    class SLDataBase
    {
        var $db;
        var $dbpath;
        var $error;
        var $lastResult;

        function SLDataBase( $host, $user, $pass, $dbname )
        {
            $this->dbpath = SL_ROOT.".sqlitedb/database";
        }
    
        
        function connect()
        {
            $result = true;
            $error = "";
            
            $conn = sqlite_open( $this->dbpath, 0666, $error );

            if ( is_resource( $conn ) )
            {
                $this->db = $conn;
                $result = true;
            }
            else
            {
                $result = false;
                $this->error = "Could not open the SQLite Database: ".$error;
            }

            return $result;
        }

        function close()
        {
            @sqlite_close( $this->db );
        }

        function createDataBase()
        {
            if ( !is_dir( SL_ROOT.".sqlitedb" ) )
            {
                mkdir( SL_ROOT.".sqlitedb"  );
            }

            $conn = sqlite_open( $this->dbpath, 0666, $error );

            if ( is_resource( $conn ) )
            {
                $this->db = $conn;
                $result = true;
            }
            else
            {
                $this->error = "Could not create the database: ".$error;
                $result = false;
            }
            
            return $result;
        }
        
        function getError()
        {
            return $this->error;
        }

        function query( $sql )
        {
            $qr = @sqlite_query( $this->db, $sql );
            
            $result = true;

            if ( is_resource( $qr ) )
            {
                $this->lastResult = array();
                
                while( $row = @sqlite_fetch_array( $qr ) )
                {
                    array_push( $this->lastResult, $row );
                }
            }
            else if ( $qr )
            {
                $result = $qr;
            }
            else
            {
                $result = false;
                $this->error = sqlite_error_string( sqlite_last_error( $this->db ) );
            }
            
            return $result;
        }

        function getLastResult()
        {
            return $this->lastResult;
        }
    }
}
?>
