<?php

require_once( "core/db/util/SQLStatement.php" );

if ( !defined( "_SL_DAILY_STATS" ) ){
      define( "_SL_DAILY_STATS", 1 );

    class SLDailyStats 
    {
        var $db;
        var $date;
        var $browses;
        var $streams;
        var $downloads;
        
        function SLDailyStats( $db, $date )
        {
            $this->db = $db;
            $this->date = $date;
            $this->load();
        }

        function getDate()
        {
            return $this->date;
        }

        function getBrowses()
        {
            return $this->browses;
        }
        
        function incrementBrowses()
        {
            $this->browses++;
        }
        
        function getStreams()
        {
            return $this->streams;
        }
        
        function incrementStreams()
        {
            $this->streams++;
        }

        function getDownloads()
        {
            return $this->downloads;
        }
        
        function incrementDownloads()
        {
            $this->downloads++;
        }

        function load()
        {
            $sql = SQLStatement::createStatement( "SELECT * FROM stats_daily WHERE date = ?" );
            $sql->setValue( 0, $this->date );
            
            $this->db->query( $sql->toSQL() );
            $rows = $this->db->getLastResult();
            $row = $rows[0];

            $this->browses = $row['browses'];
            $this->streams = $row['streams'];
            $this->downloads = $row['downloads'];
        }

        function store()
        {
            $sql = SQLStatement::createStatement( 
                "UPDATE stats_daily SET browses = ?, streams = ?, downloads = ? WHERE date = ?" 
            );

            $sql->setValue( 0, $this->browses );
            $sql->setValue( 1, $this->streams );
            $sql->setValue( 2, $this->downloads );
            $sql->setValue( 3, $this->date );
            
            return $this->db->query( $sql->toSQL() );
        }
    }
}
?>
