<?php

require_once( "core/db/util/SQLStatement.php" );

if ( !defined( "_SL_HAC_ENTRY" ) ){
      define( "_SL_HAC_ENTRY", 1 );

    class SLHACEntry 
    {
        var $db;
        var $entryid;
        var $start;
        var $end;
        var $rule;
        var $service;
        
        function SLHACEntry( $db, $entryid )
        {
            $this->db = $db;
            $this->entryid = $entryid;
            $this->load();
        }

        function getEntryId()
        {
            return $this->entryid;
        }


        function getStartIP()
        {
            return $this->start;
        }

        function setStartIP( $startip )
        {
            $this->start = $startip;
        }


        function getEndIP()
        {
            return $this->end;
        }

        function setEndIP( $endip )
        {
            $this->end = $endip;
        }
        
        
        function getRule()
        {
            return $this->rule;
        }

        function setRule( $rule )
        {
            $this->rule = $rule;
        }


        function getService()
        {
            return $this->service;
        }

        function setService( $service )
        {
            $this->service = $service;
        }


        function load()
        {
            $sql = SQLStatement::createStatement( "SELECT * FROM host_access WHERE entryid = ?" );
            $sql->setValue( 0, $this->entryid );
            
            $this->db->query( $sql->toSQL()  );
            $rows = $this->db->getLastResult();
            $row = $rows[0];

            $this->start = $row['startip'];
            $this->end = $row['endip'];
            $this->rule = $row['rule'];
            $this->service = $row['service'];
        }

        
        function store()
        {
            $sql = SQLStatement::createStatement( 
                "UPDATE host_access SET startip = ?, endip = ?, rule = ?, service = ? WHERE entryid = ?" 
            );

            $sql->setValue( 0, addslashes( $this->start ) );
            $sql->setValue( 1, addslashes( $this->end ) );
            $sql->setValue( 2, addslashes( $this->rule ) );
            $sql->setValue( 3, addslashes( $this->service ) );
            $sql->setValue( 4, addslashes( $this->entryid ) );
            
            return $this->db->query( $sql->toSQL() );
        }
    }
}
?>
