<?php

require_once( "core/db/util/SQLStatement.php" );

if ( !defined( "_SL_LAST_LOGIN" ) ){
      define( "_SL_LAST_LOGIN", 1 );

    class SLLastLogin 
    {
        var $db;
        var $uid;
        
        var $time;
        var $host;
        
        function SLLastLogin( $db, $uid )
        {
            $this->db = $db;
            $this->uid = $uid;
            $this->load();
        }

        function getUID()
        {
            return $this->uid;
        }

        function getTime()
        {
            return $this->time;
        }

        function setTime( $time )
        {
            $this->time = $time;
        }

        function getHost()
        {
            return $this->host;
        }

        function setHost( $host )
        {
            $this->host = $host;
        }

        
        function load()
        {
            $sql = SQLStatement::createStatement( "SELECT * FROM lastlogin WHERE uid = ?" );
            $sql->setValue( 0, $this->uid );

            $this->db->query( $sql->toSQL()  );
            $rows = $this->db->getLastResult();
            $row = $rows[0];

            $this->time = $row['time'];
            $this->host = $row['host'];
        }

        function store()
        {
            $sql = SQLStatement::createStatement( "UPDATE lastlogin SET time = ?, host = ? WHERE uid = ?" );

            $sql->setValue( 0, $this->time );
            $sql->setValue( 1, $this->host );
            $sql->setValue( 2, $this->uid );
            
            return $this->db->query( $sql->toSQL() );
        }
    }
}
?>
