<?php

require_once( "core/db/util/SQLStatement.php" );

if ( !defined( "_SL_MEDIA" ) ){
      define( "_SL_MEDIA", 1 );

    class SLMedia 
    {
        var $db;
        var $path;
        
        var $title;
        var $artist;
        var $album;
        var $genre;
        var $year;
        var $filename;
        var $modtime;
        
        function SLMedia( $db, $path )
        {
            $this->db = $db;
            $this->path = $path;
            $this->load();
        }

        function getPath()
        {
            return $this->path;
        }

        
        function getTitle()
        {
            return $this->title;
        }

        function setTitle( $title )
        {
            $this->title = $title;
        }

        
        function getAlbum()
        {
            return $this->album;
        }
        
        function setAlbum( $album )
        {
             $this->album = $album;
        }
        
        
        function getArtist()
        {
            return $this->artist;
        }

        function setArtist( $artist )
        {
            $this->artist = $artist;
        }

        
        function getGenre()
        {
            return $this->genre;
        }
        
        function setGenre( $genre )
        {
            $this->genre = $genre;
        }


        function getYear()
        {
            return $this->year;
        }

        function setYear( $year )
        {
            $this->year = $year;
        }

        function getFileName()
        {
            return $this->filename;
        }

        function setFileName( $filename )
        {
            $this->filename = $filename;
        }

        function getModTime()
        {
            return $this->modtime;
        }

        function setModTime( $modtime )
        {
            $this->modtime = $modtime;
        }


        function load()
        {
            $sql = SQLStatement::createStatement( "SELECT * FROM media WHERE path = ?" );
            $sql->setValue( 0, $this->path );
            
            $this->db->query( $sql->toSQL()  );
            $rows = $this->db->getLastResult();
            $row = $rows[0];

            $this->title = $row['title'];
            $this->album = $row['album'];
            $this->artist = $row['artist'];
            $this->genre = $row['genre'];
            $this->year = $row['year'];
            $this->filename = $row['filename'];
            $this->modtime = $row['modtime'];
        }

        
        function store()
        {
            $sql = SQLStatement::createStatement( 
                "UPDATE media SET title = ?, album = ?, artist = ?, genre = ?, year = ?, filename = ?, modtime = ? WHERE path = ?" 
            );
            
            $sql->setValue( 0, $this->title );
            $sql->setValue( 1, $this->album );
            $sql->setValue( 2, $this->artist );
            $sql->setValue( 3, $this->genre );
            $sql->setValue( 4, $this->year );
            $sql->setValue( 5, $this->filename );
            $sql->setValue( 6, $this->modtime );
            $sql->setValue( 7, $this->path );
            
            return $this->db->query( $sql->toSQL() );
        }
    }
}
?>
