<?php

require_once( "core/db/util/SQLStatement.php" );

if ( !defined( "_SL_MEDIA_STATS" ) ){
      define( "_SL_MEDIA_STATS", 1 );

    class SLMediaStats 
    {
        var $db;
        var $path;
        var $streams;
        var $downloads;
        
        function SLMediaStats( $db, $path )
        {
            $this->db = $db;
            $this->path = $path;
            $this->load();
        }

        function getPath()
        {
            return $this->path;
        }

        function getStreams()
        {
            return $this->streams;
        }
        
        function incrementStreams()
        {
            $this->streams++;
        }

        function getDownloads()
        {
            return $this->downloads;
        }
        
        function incrementDownloads()
        {
            $this->downloads++;
        }

        function load()
        {
            $sql = SQLStatement::createStatement( "SELECT * FROM stats_media WHERE path = ?" );
            $sql->setValue( 0, $this->path );
            
            $this->db->query( $sql->toSQL() );
            $rows = $this->db->getLastResult();
            $row = $rows[0];

            $this->streams = $row['streams'];
            $this->downloads = $row['downloads'];
        }


        function store()
        {
            $sql = SQLStatement::createStatement( 
                "UPDATE stats_media SET streams = ?, downloads = ? WHERE path = ?" 
            );

            $sql->setValue( 0, $this->streams );
            $sql->setValue( 1, $this->downloads );
            $sql->setValue( 2, $this->path );
            
            return $this->db->query( $sql->toSQL() );
        }
    }
}
?>
