<?php

require_once( "core/db/util/SQLStatement.php" );

if ( !defined( "_SL_MEDIA_TYPE" ) ){
      define( "_SL_MEDIA_TYPE", 1 );

    class SLMediaType 
    {
        var $db;
        var $extension;
        
        var $description;
        var $icon;
        var $enabled;
        
        function SLMediaType( $db, $extension )
        {
            $this->db = $db;
            $this->extension = $extension;
            $this->load();
        }

        function getExtension()
        {
            return $this->extension;
        }

        
        function getDescription()
        {
            return $this->description;
        }

        function setDescription( $description )
        {
            $this->description = $description;
        }

        
        function getIcon()
        {
            return $this->icon;
        }

        function setIcon( $icon )
        {
            $this->icon = $icon;
        }

        function getEnabled()
        {
            return $this->enabled;
        }

        function setEnabled( $enabled )
        {
            $this->enabled = $enabled;
        }

        
        function load()
        {
            $sql = SQLStatement::createStatement( "SELECT * FROM media_type WHERE extension = ?" );
            $sql->setValue( 0, $this->extension );
            
            $this->db->query( $sql->toSQL()  );
            $rows = $this->db->getLastResult();
            $row = $rows[0];

            $this->description = $row['description'];
            $this->icon = $row['icon'];
            $this->enabled = $row['enabled'];
        }

        
        function store()
        {
            $sql = SQLStatement::createStatement( 
                "UPDATE media_type SET description = ?, icon = ?, enabled = ? WHERE extension = ?" 
            );

            $sql->setValue( 0, $this->description );
            $sql->setValue( 1, $this->icon );
            $sql->setValue( 2, $this->enabled );
            $sql->setValue( 3, $this->extension );

            return $this->db->query( $sql->toSQL() );
        }
    }
}
?>
