<?php

require_once( "core/db/util/SQLStatement.php" );

if ( !defined( "_SL_USER_STATS" ) ){
      define( "_SL_USER_STATS", 1 );

    class SLUserStats 
    {
        var $db;
        var $uid;
        var $streams;
        var $downloads;
        
        function SLUserStats( $db, $uid )
        {
            $this->db = $db;
            $this->uid = $uid;
            $this->load();
        }

        function getUserId()
        {
            return $this->uid;
        }

        function getStreams()
        {
            return $this->streams;
        }
        
        function incrementStreams()
        {
            $this->streams++;
        }

        function getDownloads()
        {
            return $this->downloads;
        }
        
        function incrementDownloads()
        {
            $this->downloads++;
        }

        function load()
        {
            $sql = SQLStatement::createStatement( "SELECT * FROM stats_user WHERE uid = ?" );
            $sql->setValue( 0, $this->uid );
            
            $this->db->query( $sql->toSQL() );
            $rows = $this->db->getLastResult();
            $row = $rows[0];

            $this->streams = $row['streams'];
            $this->downloads = $row['downloads'];
        }


        function store()
        {
            $sql = SQLStatement::createStatement( 
                "UPDATE stats_user SET streams = ?, downloads = ? WHERE uid = ?" 
            );

            $sql->setValue( 0, $this->streams );
            $sql->setValue( 1, $this->downloads );
            $sql->setValue( 2, $this->uid );
            
            return $this->db->query( $sql->toSQL() );
        }
    }
}
?>
