<?php

require_once( "core/db/objects/SLBrowseLog.php" );
require_once( "core/db/util/SQLStatement.php" );

if ( !defined( "_SL_BROWSE_LOG_TABLE" ) ){
      define( "_SL_BROWSE_LOG_TABLE", 1 );

    class SLBrowseLogTable
    {
        var $db;

        function SLBrowseLogTable( $db )
        {
            $this->db = $db;
        }

        
        function addLogEntry( $host, $user, $resource )
        {
            $template ="INSERT INTO browselog (time, host, uname, rsrc) VALUES ( ?, ?, ?, ?)";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, time() );
            $sql->setValue( 1, $host );
            $sql->setValue( 2, $user );
            $sql->setValue( 3, $resource );
            
            $result = $this->db->query( $sql->toSQL() );
            return $result;
        }

        function deleteAllEntries()
        {
            $sql = "DELETE FROM browselog WHERE 1";
            
            $result = $this->db->query( $sql );
            return $result;
        }
        
        function deleteEntriesOlderThanTime( $time )
        {
            $template = "DELETE FROM browselog WHERE time < ?";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, $time );
            
            $result = $this->db->query( $sql->toSQL() );
            return $result;
        }
        
        function getNumberOfRows()
        {
            $qr = $this->db->query( "SELECT COUNT(logid) from browselog" );
            if ( $qr )
            {
                $last = $this->db->getLastResult();
                $result = array_pop( $last[0] );
            }
            else
            {
                $result = -1;
            }

            return $result;
        }

        
        function getLogEntryRange( $num_per_page, $start )
        {
            $result = array();
            
            $template = "SELECT logid FROM browselog ORDER BY time DESC LIMIT ? OFFSET ?";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, $num_per_page );
            $sql->setValue( 1, $start );
            $qr = $this->db->query( $sql->toSQL() );
            
            if ( $qr )
            {
                $rows = $this->db->getLastResult(); 
                foreach( $rows as $row )
                {
                    array_push( $result, new SLBrowseLog( $this->db, $row['logid'] ) );
                }
            }
            
            return $result;
        }

        
        function getAllLogEntries()
        {
            $qr = $this->db->query( "SELECT logid FROM browselog" );
            if ( $qr )
            {
                $result = array();
                $rows = $this->db->getLastResult(); 
                foreach( $rows as $row )
                {
                    array_push( $result, new SLBrowseLog( $this->db, $row['logid'] ) );
                }
            }
            
            return $result;
        }
    }
}
?>
