<?php

require_once( "core/db/objects/SLConfigOption.php" );
require_once( "core/db/util/SQLStatement.php" );

if ( !defined( "_SL_CONFIG_TABLE" ) ){
      define( "_SL_CONFIG_TABLE", 1 );

    class SLConfigTable
    {
        var $db;

        function SLConfigTable( $db )
        {
            $this->db = $db;
        }

        function removeOption( $option )
        {
            $sql = SQLStatement::createStatement( "DELETE FROM config WHERE option = ? )" );
            $sql->setValue( 0, $option );
            return $this->db->query( $sql->toSQL() );
        }

        function addOption( $option, $value )
        {
            $sql = SQLStatement::createStatement( "INSERT INTO config (option, value) VALUES (?, ?)" );
            $sql->setValue( 0, $option );
            $sql->setValue( 1, $value );
            return $this->db->query( $sql->toSQL() );
        }
        
        
        function getOption( $option )
        {   
            $sql = SQLStatement::createStatement( "SELECT name FROM config WHERE name = ?" );
            $sql->setValue( 0, $option );
            $qr = $this->db->query( $sql->toSQL() );

            $result = null;
            
            if ( $qr )
            {
                $rows = $this->db->getLastResult();
                if ( is_array( $rows ) && count( $rows ) > 0 )
                {
                    $result = new SLConfigOption( $this->db, $rows[0]['name'] );
                }
            }
            
            return $result;
        }

        
        function getAllOptions()
        {
            $result = null;
            $qr = $this->db->query( "SELECT name FROM config" );

            if ( $qr )
            {
                $result = array();
                $rows = $this->db->getLastResult();
                
                foreach( $rows as $row )
                {
                    array_push( $result, new SLConfigOption( $this->db, $row['name'] ) );
                }
            }
            
            return $result;
        }
    }
}
?>
