<?php

require_once( "core/db/objects/SLErrorLog.php" );
require_once( "core/db/util/SQLStatement.php" );

if ( !defined( "_SL_ERROR_LOG_TABLE" ) ){
      define( "_SL_ERROR_LOG_TABLE", 1 );

    class SLErrorLogTable
    {
        var $db;

        function SLErrorLogTable( $db )
        {
            $this->db = $db;
        }

        
        function addLogEntry( $host, $user, $msg )
        {
            $template = "INSERT INTO errorlog (time, host, uname, msg) VALUES (?, ?, ?, ?)";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, time() );
            $sql->setValue( 1, $host );
            $sql->setValue( 2, $user );
            $sql->setValue( 3, $msg );
            
            $result = $this->db->query( $sql->toSQL() );
            return $result;
        }

        function deleteAllEntries()
        {
            $sql = "DELETE FROM errorlog WHERE 1";
            
            $result = $this->db->query( $sql );
            return $result;
        }
        
        function deleteEntriesOlderThanTime( $time )
        {
            $template = "DELETE FROM errorlog WHERE time < ?";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, $time );
            
            $result = $this->db->query( $sql->toSQL() );
            return $result;
        }
        
        function getNumberOfRows()
        {
            $result = 0;

            $qr = $this->db->query( "SELECT COUNT(logid) from errorlog" );
            if ( $qr )
            {
                $last = $this->db->getLastResult();
                $result = array_pop( $last[0] );
            }
            else
            {
                $result = -1;
            }
            
            return $result;
        }

        
        function getLogEntryRange( $num_per_page, $page )
        {
            $result = array();
            $start = $num_per_page * $page;

            $template = "SELECT logid FROM errorlog ORDER BY time DESC LIMIT ? OFFSET ?";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, $num_per_page );
            $sql->setValue( 1, $start );
            $qr = $this->db->query( $sql->toSQL() );

            if ( $qr )
            {
                $rows = $this->db->getLastResult(); 
                foreach( $rows as $row )
                {
                    array_push( $result, new SLErrorLog( $this->db, $row['logid'] ) );
                }
            }
            
            return $result;
        }

        
        function getAllLogEntries()
        {
            $result = array();
            $qr = $this->db->query( "SELECT logid FROM errorlog" );
            if ( $qr )
            {
                $rows = $this->db->getLastResult(); 
                foreach( $rows as $row )
                {
                    array_push( $result, new SLErrorLog( $this->db, $row['logid'] ) );
                }
            }
            
            return $result;
        }
    }
}
?>
