<?php

require_once( "core/db/objects/SLLastLogin.php" );
require_once( "core/db/util/SQLStatement.php" );

if ( !defined( "_SL_LAST_LOGIN_TABLE" ) ){
      define( "_SL_LAST_LOGIN_TABLE", 1 );

    class SLLastLoginTable
    {
        var $db;

        function SLLastLoginTable( $db )
        {
            $this->db = $db;
        }

        
        function addLastLoginForUser( $uid, $time, $host )
        {
            $template = "INSERT INTO lastlogin ( uid, time, host ) VALUES ( ?, ?, ? )";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, $uid );
            $sql->setValue( 1, $time );
            $sql->setValue( 2, $host );
            
            $result = $this->db->query( $sql->toSQL() );
            return $result;
        }

        function deleteLastLoginForUID( $uid )
        {
            $template ="DELETE FROM lastlogin WHERE uid = ?";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, $uid );
            
            $result = $this->db->query( $sql->toSQL() );
            return $result;
        }
        
        function removeLastLoginForUIDsNot( $uids )
        {
            $where_clause = "(";
            
            $count = count( $uids );
      
            for ( $i = 0; $i < $count; $i++ )
            {
                if ( $where_clause != "(" )
                {
                    $where_clause .= " OR ";
                }
                
                $where_clause .= "uid = ?";
            }

            $where_clause .= ")";

            $where = SQLStatement::createStatement( $where_clause );
            
            for ( $i = 0; $i < $count; $i++ )
            {
                $where->setValue( $i, $uids[$i] );
            }

            $where_sql = $where->toSQL();
            $sql = "DELETE FROM lastlogin WHERE NOT $where_sql";
            $result = $this->db->query( $sql );

            return $result;
        }
        

        function getLastLoginForUid( $uid )
        {
            $result = null;
            $template = "SELECT uid FROM lastlogin WHERE uid = ?";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, $uid );
            
            $qr = $this->db->query( $sql->toSQL() );

            if ( $qr )
            {
                $rows = $this->db->getLastResult();
                if ( is_array( $rows ) && count( $rows ) > 0 )
                {
                    $result = new SLLastLogin( $this->db, $rows[0]['uid'] );
                }
            }

            return $result;
        }

        function lastLoginExists( $uid )
        {
            $result = false;
            $template = "SELECT uid FROM lastlogin WHERE uid = ?";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, $uid );
            
            $qr = $this->db->query( $sql->toSQL() );
            
            if ( $qr )
            {
                $rows = $this->db->getLastResult();
                $result = count( $rows ) > 0;
            }
            
            return $result;
        }
    }
}
?>
