<?
if ( !defined( "_SL_DB_MAINTAINER" ) ){
      define( "_SL_DB_MAINTAINER", 1 );

    class SLDBMaintainer 
    {
        var $db;
        
        function SLDBMaintainer( &$db )
        {
            $this->db = &$db;
        }

        function removeDeletedUserArtifacts()
        {
            require_once( "core/db/tables/SLUserTable.php" );
            require_once( "core/db/tables/SLPlayListTable.php" );
            require_once( "core/db/tables/SLPLEntryTable.php" );
            require_once( "core/db/tables/SLLastLoginTable.php" );
            require_once( "core/db/tables/SLUserStatsTable.php" );

            $user_table = &new SLUserTable( $this->db );
            
            $users = $user_table->getAllUsers();

            $uids = array();

            foreach( $users as $user )
            {
                $uids[] = $user->getUserId();
            }

            $ll_table = &new SLLastLoginTable( $this->db );
            $ll_table->removeLastLoginForUIDsNot( $uids ); 
            
            $user_stats_table = &new SLUserStatsTable( $this->db );
            $user_stats_table->removeStatsForUIDsNot( $uids ); 
            
            $playlist_table = &new SLPlayListTable( $this->db );
            $playlist_table->removeListsForUIDsNot( $uids ); 
        
            $lists = $playlist_table->getAllPlayLists();

            $list_ids = array();

            foreach( $lists as $list )
            {
                $list_ids[] = $list->getListId();
            }
            $plentry_table = &new SLPLEntryTable( $this->db );
            $plentry_table->removeEntriesForListIDsNot( $list_ids ); 
        }


        function truncateLogs( $time )
        {
            require_once( "core/db/tables/SLStreamLogTable.php" );
            require_once( "core/db/tables/SLDownloadLogTable.php" );
            require_once( "core/db/tables/SLBrowseLogTable.php" );
            require_once( "core/db/tables/SLErrorLogTable.php" );

            $stream_table = &new SLStreamLogTable( $this->db );
            $browse_table = &new SLBrowseLogTable( $this->db );
            $download_table = &new SLDownloadLogTable( $this->db );
            $error_table = &new SLErrorLogTable( $this->db );

            $stream_table->deleteEntriesOlderThanTime( $time );
            $browse_table->deleteEntriesOlderThanTime( $time );
            $download_table->deleteEntriesOlderThanTime( $time );
            $error_table->deleteEntriesOlderThanTime( $time );
        }


        function truncateStats()
        {
            require_once( "core/db/tables/SLDailyStatsTable.php" );
            $stats_table = &new SLDailyStatsTable( $this->db );
            $stats_table->deleteEntriesOlderThanTime( $time );
        }

    }
}
?>
