<?php

if ( !isset( $sl_db_type ) )
{
    @include_once( "config/db.conf.php" );
}

if ( !defined( "_SQL_STATEMENT" ) ){
      define( "_SQL_STATEMENT", 1 );

    class SQLStatement
    {
        var $template;    // The string that is the template.
        var $values;      // The values to fill the template with.

        function SQLStatement( $template )
        {
            $this->template = $template;
            $num = substr_count( $this->template, "?" );

            $this->values = array();

            for( $i = 0; $i < $num; $i++ )
            {
                array_push( $this->values, "" );
            }
        }

        function createStatement( $template )
        {
            global $sl_db_type;
            $result = null;
            
            switch( $sl_db_type )
            {
                case 'mysql':
                    require_once( "core/db/connectors/mysql/MySQLStatement.php");
                    $result = new MySQLStatement( $template );
                    break;

                case 'postgresql':
                    require_once( "core/db/connectors/postgresql/PostgreSQLStatement.php");
                    $result = new PostgreSQLStatement( $template );
                    break;

                case 'sqlite':
                    require_once( "core/db/connectors/sqlite/SQLiteStatement.php");
                    $result = new SQLiteStatement( $template );
                    break;

                default:
                    require_once( "core/db/util/SQLStatement.php");
                    $result = new SQLStatement( $template );
                    break;
            }

            return $result;
        }
    
    
        function setValue( $index, $value )
        {
            if ( is_numeric( $value ) )
            {
                $this->values[$index] = $value;
            }
            else
            {
                $this->values[$index] = "'$value'";
            }
        }

        function toSQL()
        {
            $array = explode( "?", $this->template );
            $count = count( $array );
            
            $result = $array[0];
            
            for( $i = 1; $i < $count; $i++ )
            {
                $result .= $this->values[$i - 1].$array[$i];
            }
            
            return $result;
        }
    }
}
?>
