<?
require_once( "core/getid3/getid3.php" );

if ( !defined( "_MEDIA_INFO_READER" ) ){
      define( "_MEDIA_INFO_READER", 1 );

    
    class MediaInfoReader 
    {
        var $path;
        var $parser;

        function MediaInfoReader( $path )
        {
            $this->path = $path;
        }

        function readMediaInfo()
        {
            $getid3 = &new getID3();
            
            $info = $getid3->analyze( $this->path );

            $parser = null;

            $format = $info['fileformat']; 

            // If getid3 did not give us a fileformat then fall back to the
            // extension.
            if ( !isset( $format ) )
            {
                $tmp = explode( ".", $this->path );
                $format = array_pop( $tmp );
            }

            switch( strtolower( $format ) )
            {
                case "mp3":
                    $this->setMP3Parser( $info );
                    break;

                case "ogg":
                    $this->setOGGParser( $info );
                    break;

                case "riff":
                    $this->handleRiff( $info );
                    break;
                    
            }
            
            if ( !isset( $this->parser ) )
            {
                require_once( "core/media_info/parsers/GenericAudioInfoParser.php" );
                $this->parser = new GenericAudioInfoParser( $info ); 
            }
        }

        function handleRiff( $info )
        {
            $data_format = $info['audio']['dataformat'];
            echo $data_format;
            switch( strtolower( $data_format ) )
            {
                case "mp3":
                    $this->setMP3Parser( $info );
                    break;
            }
        }

        function setMP3Parser( $info )
        {
            require_once( "core/media_info/parsers/MP3InfoParser.php" );
            $this->parser = new MP3InfoParser( $info );
        }
            

        function setOGGParser( $info )
        {
            require_once( "core/media_info/parsers/OGGInfoParser.php" );
            $this->parser = new OGGInfoParser( $info );
        }
        
                
        function getArtist()
        {
            return $this->parser->getArtist();
        }
        
        function getTitle()
        {
            return $this->parser->getTitle();
        }
        
        function getAlbum()
        {
            return $this->parser->getAlbum();
        }
        
        function getTrack()
        {
            return $this->parser->getTrack();
        }
        
        function getYear()
        {
            return $this->parser->getYear();
        }
        
        function getGenre()
        {
            return $this->parser->getGenre();
        }

        function getBitrate()
        {
            return $this->parser->getBitrate();
        }

        function getSampleRate()
        {
            return $this->parser->getSampleRate();
        }
        
        function getChannels()
        {
            return $this->parser->getChannels();
        }

        function getLength()
        {
            return $this->parser->getLength();
        }

        function getSeconds()
        {
            return $this->parser->getSeconds();
        }


        function getFileName()
        {
            return $this->parser->getFileName();
        }

        function getMimeType()
        {
            return $this->parser->getMimeType();
        }
    }
}
?>
