<?

require_once( "core/media_info/parsers/GenericAudioInfoParser.php" );
    
if ( !defined( "_MP3_INFO_PARSER" ) ){
      define( "_MP3_INFO_PARSER", 1 );

    class MP3InfoParser extends GenericAudioInfoParser
    {
        var $has_v1;
        var $id3v1;
        var $has_v2;
        var $id3v2;
        var $mpeg_audio;
        
        function MP3InfoParser( &$info )
        {
            parent::GenericAudioInfoParser( $info );
            
            $tags = &$this->info["tags"];
            if ( isset( $tags ) )
            {
                $tags = array_keys( $tags );
                foreach( $tags as $tag )
                {
                    switch( $tag )
                    {
                        case "id3v1":
                            $this->has_v1 = true;
                            $this->id3v1 = &$this->info["id3v1"];
                            break;
                        case "id3v2":
                            $this->has_v2 = true;
                            $this->id3v2 = &$this->info["id3v2"];
                            break;
                    
                        default:
                            break;
                    }
                }
            }

            $this->mpeg_audio = &$this->info["mpeg"]["audio"];
        }
        
        // Coment Info Overriding 
        
        function getArtist()
        {
            return $this->getId3Val( "artist" );
        }
        
        function getTitle()
        {
            return $this->getId3Val( "title" );
        }
        
        function getAlbum()
        {
            return $this->getId3Val( "album" );
        }
        
        function getTrack()
        {
            return $this->getId3Val( "track" );
        }
        
        function getYear()
        {
            return $this->getId3Val( "year" );
        }
        
        function getGenre()
        {
            return $this->getId3Val( "genre" );
        }
        
        function getId3Val( $key )
        {
            $result = "";
            
            if ( $this->has_v2 && array_key_exists( $key, $this->id3v2["comments"] ) )
            {
                
                $result = $this->id3v2["comments"][$key][0];
            }
            
            if ( (!$this->has_v2 || !strcmp( $result, "" )) && 
                 ( $this->has_v1 && array_key_exists( $key, $this->id3v1["comments"] ) ) )
            {
                $result = $this->id3v1["comments"][$key][0];
            }

            return $result;
        }       
        
        function getVersion()
        {
            return $this->mpeg_audio["version"];
        }


        function getLayer()
        {
            return $this->mpeg_audio["layer"];
        }
    }
}
?>
