<?
require_once( "core/streamline_functions.php" );

if ( !defined( "_SL_PL_DIR_ADDER" ) ){
      define( "_SL_PL_DIR_ADDER", 1 );

    class SLPLDirAdder
    {
        var $media_root;
        var $info_cache;
        var $cur_list;
        
        function SLPLDirAdder( $media_root, $info_cache )
        {
            $this->media_root = $media_root;
            $this->info_cache = $info_cache;
            $this->cur_list = $_SESSION[SL_CUR_PLAYLIST];
        }
        
        function addDir( $loc )
        {
            $this->recurseDir( $loc );
            $_SESSION[SL_CUR_PLAYLIST] = $this->cur_list;
        }

        function recurseDir( $loc )
        {
            set_time_limit( 20 );
            
            $cur_path = joinFilePath( $this->media_root, $loc ); 
            
            if ( is_dir( $cur_path ) )
            {
                $handle=opendir( $cur_path );

                if ( $cur_path{ strlen( $cur_path ) - 1 } != '/' )
                {
                    $cur_path = $cur_path."/";
                }
        
                $files = array();
                $dirs = array();
        
                /* This is the correct way to loop over the directory. */
                while (false !== ( $file = readdir($handle) ) ) 
                {
                    
                    if( $file == "." || $file == ".." )
                    {
                        continue;
                    }
            
                    $path = joinFilePath( $cur_path, $file );
                    
                    if ( is_dir( $path  ) )
                    {
                        array_push( $dirs, $file );
                    }
                    else if ( is_file( $path ) )
                    {
                        array_push( $files, $file );
                    }
                }

                sort( $files );
                sort( $dirs );

                $all = $dirs + $files;
                $c = count( $all );
                
                for ( $i = 0; $i < $c; $i++ )
                {
                    $entry = $all[$i];

                    if ( is_file( joinFilePath( $cur_path, $entry ) ) )
                    {
                        $array = explode( ".", $entry );
                        $ext = array_pop( $array );

                        global $sl_media_types;
                    
                        if ( !array_key_exists( $ext, $sl_media_types ) )
                        {
                            continue;
                        }
                    }

                    $this->recurseDir( joinFilePath( $loc, $entry ) );
                }
            }
            else if ( is_file( $cur_path ) )
            {
                $info = $this->info_cache->getMediaInfo( $loc );
                $this->cur_list->addItem( new PlayListItem( $loc, $info ) );
            }
        }
    }
}
?>
