<?
require_once( "core/db/tables/SLUserStatsTable.php" );

if ( !defined( "_SL_USER_STATS_ENGINE" ) ){
      define( "_SL_USER_STATS_ENGINE", 1 );

    class SLUserStatsEngine
    {
        var $db;
        var $table;

        function SLUserStatsEngine( $db )
        {
            $this->db = &$db;
            $this->table = &new SLUserStatsTable( $this->db );
        }

        function logStream( $uid )
        {
            $stat = null;
            
            if ( !$this->table->statsExistForUser( $uid ) )
            {
                $stat = $this->table->createUserStats( $uid );
            } 
            
            $stat = $this->table->getStatsForUser( $uid );
            $stat->incrementStreams();
            $stat->store();
        }


        function getTopUsersRankedByStreams( $num, $offset = 0)
        {
            $result = array();
            $stats = $this->table->getTopRankedUsersByStreams( $num );
            
            foreach( $stats as $stat )
            {
                $result[$stat->getUserId()] = $stat->getStreams();
            }

            return $result;
        }
       

        function logDownload( $uid )
        {
            $stat = null;
            
            if ( !$this->table->statsExistForUser( $uid ) )
            {
                $stat = $this->table->createUserStats( $uid );
            } 
            
            $stat = $this->table->getStatsForUser( $uid );
            $stat->incrementDownloads();
            $stat->store();
        }
        
        function getTopUsersRankedByDownloads( $num, $offset = 0)
        {
            $result = array();
            $stats = $this->table->getTopRankedUsersByDownloads( $num );
            
            foreach( $stats as $stat )
            {
                $result[$stat->getUserId()] = $stat->getDownloads();
            }

            return $result;
        }
    }
}
?>
