<?  require_once( "core/streamline_constants.php" );
    
    // All the objects that might be in ths session need to be included here
    // first before we try to start the session.
    require_once( "core/SLConfiguration.php" );
    require_once( "core/auth/AuthUser.php" );
    require_once( "core/auth/LastLoginInfo.php" );
    require_once( "core/playlist/PlayList.php" );
    require_once( "core/SLLogger.php" );
    require_once( "core/media_info/MediaInfoCache.php" );
    require_once( "core/theme/SLTheme.php" );
    require_once( "core/access/SLAccessControler.php" );
    require_once( "core/db/tables/SLMediaTypeTable.php" );
    require_once( "core/platform/platform_require.php");
    
    session_start();

    // HACK FOR IE TO WORK WITH PLAYLISTS
    // Basically some of the headers added by the session_start()
    // call confuse IE and prevent the playlist from being loaded
    // right.
    if ( strstr( $_SERVER['HTTP_USER_AGENT'], "MSIE" ) != false )
    {
        header('Cache-Control: max-age=1, Private');
    }
    // END HACK
    
    require_once( "core/platform/platform_init.php");
    

    if ( !isset( $_SESSION[SL_CONFIG] ) )
    {
        $result = false;
        
        if ( is_readable( SL_ROOT."config/db.conf.php" ) )
        {
            require_once( "db/tables/SLConfigTable.php" );
            require_once( "core/SLConfigManager.php" );
            require_once( "db/db_init.php" );
        
            $table = new SLConfigTable( $db );
        
            $configManager = new SLConfigManager( $table );
            $result = $configManager->loadConfiguration();
        }

        if ( !$result )
        {
            header( "Location: ../installer/index.php" );
            echo "\n";
        }
        else
        {
           $sl_config =& $configManager->getConfiguration();
           $_SESSION[SL_CONFIG] =& $sl_config;
        }
    }
    else
    {
        $sl_config =& $_SESSION[SL_CONFIG];
    }
    
    if ( !isset( $_SESSION[SL_ACCESS_CONTROLER] ) )
    {
        $sl_access_controler =& new SLAccessControler( $db, $sl_config );

        $_SESSION[SL_ACCESS_CONTROLER] =& $sl_access_controler;
    }
    else
    {
        $sl_access_controler =& $_SESSION[SL_ACCESS_CONTROLER];
    }

    if ( !isset( $_SESSION[SL_LOGGER] ) )
    {
        $sl_logger =& new SLLogger( $sl_config );

        $_SESSION[SL_LOGGER] =& $sl_logger;
    }
    else
    {
        $sl_logger =& $_SESSION[SL_LOGGER];
    }

    if( !isset( $_SESSION[SL_MEDIA_INFO_CACHE] ) )
    {
        $sl_media_info_cache =& new MediaInfoCache( $sl_config->getMediaRoot() );
        $_SESSION[SL_MEDIA_INFO_CACHE] =& $sl_media_info_cache;
    }
    else
    {
        $sl_media_info_cache =& $_SESSION[SL_MEDIA_INFO_CACHE];
    }
    
    if( !isset( $_SESSION[SL_CUR_PLAYLIST] ) )
    {
        $sl_cur_playlist =& new Playlist();
        $_SESSION[SL_CUR_PLAYLIST] =& $sl_cur_playlist;
    }
    else
    {
        $sl_cur_playlist =& $_SESSION[SL_CUR_PLAYLIST];
    }

    
    if( !isset( $_SESSION[SL_MEDIA_TYPES] ) )
    {
        $table = new SLMediaTypeTable( $db );
        $tmp = $table->getEnabledMediaTypes();
        $sl_media_types = array();
        
        foreach( $tmp as $cur )
        {
            $sl_media_types[strtolower( $cur->getExtension() )] = $cur;
        }
        
        $_SESSION[SL_MEDIA_TYPES] =& $sl_media_types;
    }
    else
    {
        $sl_media_types =& $_SESSION[SL_MEDIA_TYPES];
    }


    if( !isset( $_SESSION[SL_CUR_THEME] ) )
    {
        $theme = $sl_config->getTheme(); 
        $theme_path = joinFilePath( "themes", $theme );  

        if ( !is_dir( SL_ROOT.$theme_path ) )
        {
            $sl_logger->logError( "Error Couldn't find specified theme ($theme). Using the default theme.", "no user" );
            $theme_path = "themes/default";
            $theme = "deafult";
        
            if ( !is_dir( SL_ROOT.$theme_path ) )
            {
                $sl_logger->logError( "The default theme could not be loaded.", "no user" );
            }
        }
        
        $unix_path = joinFilePath( SL_ROOT, $theme_path );
        
        $web_path = joinURLPath( $sl_config->getWebServerRoot(), $sl_config->getMediaServerRoot() );
        $web_path = joinURLPath( $web_path, joinURLPath( "themes", $theme )  );
        
        $sl_cur_theme =& new SLTheme( $theme, $unix_path, $web_path );
        $_SESSION[SL_CUR_THEME] =& $sl_cur_theme;
    }
    else
    {
        $sl_cur_theme =& $_SESSION[SL_CUR_THEME];
    }

    if ( !isset( $_SESSION[SL_BROWSER_URI] ) )
    {
        $_SESSION[SL_BROWSER_URI] = $sl_config->getMediaServerRoot();
    }
?>
