<?
require_once( "core/ui/tables/SLTableModel.php" );

if ( !defined( "_SL_SIMPLE_TABLE_MODEL" ) ){
      define( "_SL_SIMPLE_TABLE_MODEL", 1 );

    class SLSimpleTableModel extends SLTableModel
    {
        var $data;
        var $columns;
        var $window_size;
        var $window_start;

        function SLSimpleTableModel( $columns, $data )
        {
            $this->data = $data;
            $this->columns = $columns;
            $this->window_size = count( $data );
            $this->window_start = 0;
        }

        function getTotalRows()
        {
            return count( $this->data );
        }

        function getNumRows()
        {
            return min( $this->window_size, count( $this->data ) - $this->window_start);
        }

        function getNumColumns()
        {
            return count( $this->columns );
        }

        function getColumnName( $index )
        {
            return $this->columns[$index];
        }
        
        function getValue( $row, $column )
        {
            return $this->data[$row + $this->window_start][$column];
        }

        function setWindow( $size, $start )
        {
            $this->window_size = $size;
            $this->window_start = $start;
        }

        function getWindowStart()
        {
            return $this->window_start;
        }

        function getWindowSize()
        {
            return $this->window_size;
        }

        function hasNextPage()
        {
            return $this->window_start + $this->window_size < count( $this->data );
        }

        function hasPreviousPage()
        {
            return $this->window_start > 0;
        }
    }
}
?>
