<?
if ( !defined( "_SL_TABLE" ) ){
      define( "_SL_TABLE", 1 );

    class SLTable
    {
        var $width;
        var $header_bg;
        var $even_color;
        var $odd_color;
        var $border_thickness;
        var $border_color;

        var $table_model;

        function SLTable( &$table_model )
        {
            $this->table_model = &$table_model;
            $this->header_bg = "#CCCCCC";
            $this->even_color = "#EEEEEE";
            $this->odd_color = "#DDDDDD";
            $this->border_thickness = "1";
            $this->border_color = "black";
        }
        
        function setTableModel( &$table_model )
        {
            $this->table_model = &$table_model;
        }

        function & getTableModel()
        {
            return $this->table_model;
        }
        
        function setWidth( $width )
        {
            $this->width = $width;
        }

        function getWidth()
        {
            return $width;
        }
        
        function setHeaderBG( $header_bg )
        {
            $this->header_bg = $header_bg;
        }

        function getHeaderBG()
        {
            return $header_bg;
        }

        function setRowColors( $even_color, $odd_color = null )
        {
            $this->even_color = $even_color;
            $this->odd_color = isset( $odd_color )?$odd_color:$even_color;
        }

        function setEvenRowColor( $even_color )
        {
            $this->even_color = $even_color;
        }

        function getEvenRowColor()
        {
            return $this->even_color;
        }

        function setOddRowColor( $odd_color )
        {
            $this->odd_color = $odd_color;
        }

        function getOddRowColor()
        {
            return $this->odd_color;
        }

        function setBorderColor( $color )
        {
            $this->border_color = $color;
        }

        function getBorderColor()
        {
            return $this->border_color;
        }

        function setBorderThickness( $thickness )
        {
            $this->border_thickness = $thickness;
        }

        function getBorderThickness()
        {
            return $this->border_thickness;
        }

        function generateTable()
        {
            $row_count = $this->table_model->getNumRows();
            $col_count = $this->table_model->getNumColumns();
            
            $border_color = $this->border_color;
            $border_thickness = $this->border_thickness;
            $border_thickness = $this->border_thickness;
            $width = $this->width;
            
            echo "<table style=\"width: $width; border: solid ".$border_thickness."px $border_color;\">\n";
            echo "<tr>\n";
            
            
            for( $i = 0; $i < $col_count; $i++ )
            {
                $header_bg = $this->header_bg;
                echo "<td style=\"padding-left: 5px; padding-right: 5px;\"bgcolor=\"$header_bg\"><strong>".
                    $this->table_model->getColumnName( $i ).
                    "</strong></td>";
            }
            echo "</tr>\n";
            
            for( $i = 0; $i < $row_count; $i++ )
            {
                echo "<tr>\n";
                $bg_color = ($i % 2 == 0)?$this->even_color:$this->odd_color;
                for( $j = 0; $j < $col_count; $j++ )
                {
                    echo "<td style=\"padding-left: 5px; padding-right: 5px;\"bgcolor=\"$bg_color\">".
                        $this->table_model->getValue( $i, $j ).
                        "</td>";
                }

                echo "\n</tr>\n";
            }

            echo "</table>";
        }
    }
}
?>
