<?php
    require_once( "../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "core/streamline_functions.php" );
    require_once( "core/db/db_init.php" );
    require_once( "core/stats/SLDailyStatsEngine.php" );
    require_once( "core/stats/SLMediaStatsEngine.php" );
    require_once( "core/stats/SLUserStatsEngine.php" );


    // Since we use the .htaccess to direct all errors to this page,
    // we should reset the response to return code 200 in case it was
    // set to 404 for a file that doesn't exist.
    header('HTTP/1.1 200\r\n');


    $uri = stripslashes( $_SERVER['REQUEST_URI'] );

    $temp = split( "\.", $uri );
    $ext = array_pop( $temp );
    
    if ( $sl_access_controler->requireLoginForDownloading() )
    {
        require_once( "core/auth/php_login.php" );
    }
    
    if ( !$sl_access_controler->getDownloadAccess() )
    {
        $msr = $sl_config->getMediaServerRoot();
        $ad_path = joinURLPath( $msr, "download/access_denied.php" );
        header( "Location: $ad_path" );
        echo "\n";
        die();
    }
   


    
    if ( isset( $_SESSION[SL_AUTH_USER] ) )
    {
        $auth_user = $_SESSION[SL_AUTH_USER];
        
        require_once( "core/db/tables/SLUserTable.php" );
        $sl_user_table = new SLUserTable( $db );
        $sl_user = $sl_user_table->getUserById( $auth_user->getUID() );
        $_user_name = $sl_user->getUserName();
        $user_stats_engine = &new SLUserStatsEngine( $db );
        $user_stats_engine->logDownload( $sl_user->getUserId() );
    }
    else
    {
        $_user_name = "Unknown";
    }

    $dl_root = joinURLPath( $sl_config->getMediaServerRoot(), "download" );
    $mp3_root = $sl_config->getMediaRoot();
    
    $req_path = urldecode( $uri );
    $len = strlen( $req_path );
    $rootlen = strlen( $dl_root );
    $index = strpos( $req_path, $dl_root );
    $rel_path = substr( $req_path, $index + $rootlen, $len - ($index + $rootlen) );
    $mp3_path = $mp3_root.$rel_path;
    $file_size = filesize( $mp3_path );
    
    header("Content-Disposition: attachment;" );
    header("Content-Length: ".$file_size );
    header("Content-type: audio/mpeg");
    echo "\n";
    
    $mp3 = fopen( $mp3_path, "r" );

    $sl_logger->logDownload( $rel_path, $_user_name );
    $daily_stats_engine = &new SLDailyStatsEngine( $db );
    $daily_stats_engine->logDownload();
    $media_stats_engine = &new SLMediaStatsEngine( $db );
    $media_stats_engine->logDownload( $rel_path );
    
    $data = fread( $mp3, 8192 );
    while( strlen( $data ) > 0 )
    {
        echo $data;
        $data = fread( $mp3, 8192 );
    }
    
?>
