

CREATE TABLE `agent_access` (
 `entryid` bigint(20) NOT NULL auto_increment,
 `service` smallint(6) NOT NULL default '0',
 `rule` smallint(6) NOT NULL default '0',
 `pattern` varchar(255) NOT NULL default '',
 `ptype` smallint(6) NOT NULL default '0',
 PRIMARY KEY (`entryid`)
);

CREATE TABLE `browselog` (
 `logid` bigint(20) unsigned NOT NULL auto_increment,
 `time` bigint(20) unsigned NOT NULL default '0',
 `host` varchar(255) NOT NULL default '',
 `uname` varchar(20) NOT NULL default '',
 `rsrc` varchar(255) NOT NULL default '',
 PRIMARY KEY (`logid`)
);

CREATE TABLE `config` (
 `name` varchar(30) NOT NULL default '',
 `value` text NOT NULL,
 PRIMARY KEY (`name`)
);

CREATE TABLE `downloadlog` (
 `logid` bigint(20) unsigned NOT NULL auto_increment,
 `time` bigint(20) unsigned NOT NULL default '0',
 `host` varchar(255) NOT NULL default '',
 `uname` varchar(20) NOT NULL default '',
 `media` varchar(255) NOT NULL default '',
 PRIMARY KEY (`logid`)
);

CREATE TABLE `errorlog` (
 `logid` bigint(20) unsigned NOT NULL auto_increment,
 `time` bigint(20) unsigned NOT NULL default '0',
 `host` varchar(255) NOT NULL default '',
 `uname` varchar(50) NOT NULL default '',
 `msg` text NOT NULL,
 PRIMARY KEY (`logid`)
);

CREATE TABLE `host_access` (
 `entryid` bigint(20) NOT NULL auto_increment,
 `start` varchar(15) NOT NULL default '',
 `end` varchar(15) NOT NULL default '',
 `rule` varchar(5) NOT NULL default '',
 `service` varchar(10) NOT NULL default '',
 PRIMARY KEY (`entryid`)
);

CREATE TABLE `lastlogin` (
 `uid` bigint(20) NOT NULL default '0',
 `time` bigint(20) NOT NULL default '0',
 `host` varchar(250) NOT NULL default '',
 PRIMARY KEY (`uid`)
);

CREATE TABLE `media` (
 `path` text NOT NULL,
 `filename` varchar(255) NOT NULL default '',
 `title` varchar(255) NOT NULL default '',
 `album` varchar(255) NOT NULL default '',
 `artist` varchar(255) NOT NULL default '',
 `genre` varchar(255) NOT NULL default '',
 `year` varchar(4) NOT NULL default '',
 `modtime` int(11) NOT NULL default '0'
);

CREATE TABLE `media_type` (
 `extension` varchar(20) NOT NULL default '',
 `description` varchar(255) default NULL,
 `icon` varchar(255) default NULL,
 `enabled` tinyint(4) NOT NULL default '0',
 PRIMARY KEY (`extension`)
);

CREATE TABLE `playlists` (
 `listid` int(11) NOT NULL auto_increment,
 `uid` int(11) NOT NULL default '0',
 `title` varchar(255) NOT NULL default '',
 PRIMARY KEY (`listid`)
);

CREATE TABLE `plentry` (
 `entryid` bigint(20) NOT NULL auto_increment,
 `listid` int(11) NOT NULL default '0',
 `ndx` int(11) NOT NULL default '0',
 `media` text NOT NULL,
 PRIMARY KEY (`entryid`)
);

CREATE TABLE `stats_daily` (
 `date` bigint(20) NOT NULL default '0',
 `browses` bigint(20) NOT NULL default '0',
 `streams` bigint(20) NOT NULL default '0',
 `downloads` bigint(20) NOT NULL default '0',
 PRIMARY KEY (`date`)
);

CREATE TABLE `stats_media` (
 `path` text NOT NULL,
 `streams` bigint(20) NOT NULL default '0',
 `downloads` bigint(20) NOT NULL default '0'
);

CREATE TABLE `stats_user` (
 `uid` bigint(20) NOT NULL default '0',
 `streams` bigint(20) NOT NULL default '0',
 `downloads` bigint(20) NOT NULL default '0',
 PRIMARY KEY (`uid`)
);

CREATE TABLE `streamlog` (
 `logid` bigint(20) unsigned NOT NULL auto_increment,
 `time` bigint(20) unsigned NOT NULL default '0',
 `host` varchar(255) NOT NULL default '',
 `uname` varchar(20) NOT NULL default '',
 `media` varchar(255) NOT NULL default '',
 PRIMARY KEY (`logid`)
);

CREATE TABLE `users` (
 `uid` bigint(20) unsigned NOT NULL auto_increment,
 `uname` varchar(20) NOT NULL default '',
 `password` varchar(20) NOT NULL default '',
 `fname` varchar(20) NOT NULL default '',
 `lname` varchar(20) NOT NULL default '',
 `email` varchar(40) NOT NULL default '',
 `browse` tinyint(4) NOT NULL default '0',
 `stream` tinyint(4) NOT NULL default '0',
 `download` tinyint(4) NOT NULL default '0',
 `admin` tinyint(4) NOT NULL default '0',
 `xmmscmpt` tinyint(4) NOT NULL default '0',
 PRIMARY KEY (`uid`)
);
