

CREATE TABLE agent_access (
 entryid SERIAL,
 service smallint NOT NULL default '0',
 rule smallint NOT NULL default '0',
 pattern varchar(255) NOT NULL default '',
 ptype smallint NOT NULL default '0',
 PRIMARY KEY (entryid)
);

CREATE TABLE browselog (
 logid SERIAL,
 time bigint NOT NULL default '0',
 host varchar(255) NOT NULL default '',
 uname varchar(20) NOT NULL default '',
 rsrc varchar(255) NOT NULL default '',
 PRIMARY KEY (logid)
);

CREATE TABLE config (
 name varchar(30) NOT NULL default '',
 value text NOT NULL,
 PRIMARY KEY (name)
);

CREATE TABLE downloadlog (
 logid SERIAL,
 time bigint NOT NULL default '0',
 host varchar(255) NOT NULL default '',
 uname varchar(20) NOT NULL default '',
 media varchar(255) NOT NULL default '',
 PRIMARY KEY (logid)
);

CREATE TABLE errorlog (
 logid SERIAL,
 time bigint NOT NULL default '0',
 host varchar(255) NOT NULL default '',
 uname varchar(50) NOT NULL default '',
 msg text NOT NULL,
 PRIMARY KEY (logid)
);

CREATE TABLE host_access (
 entryid SERIAL,
 start varchar(15) NOT NULL default '',
 end varchar(15) NOT NULL default '',
 rule varchar(5) NOT NULL default '',
 service varchar(10) NOT NULL default '',
 PRIMARY KEY (entryid)
);

CREATE TABLE lastlogin (
 uid bigint NOT NULL default '0',
 time bigint NOT NULL default '0',
 host varchar(250) NOT NULL default '',
 PRIMARY KEY (uid)
);

CREATE TABLE media (
 path text NOT NULL,
 filename varchar(255) NOT NULL default '',
 title varchar(255) NOT NULL default '',
 album varchar(255) NOT NULL default '',
 artist varchar(255) NOT NULL default '',
 genre varchar(255) NOT NULL default '',
 year varchar(4) NOT NULL default '',
 modtime int NOT NULL default '0'
);

CREATE TABLE media_type (
 extension varchar(20) NOT NULL default '',
 description varchar(255) default NULL,
 icon varchar(255) default NULL,
 enabled smallint NOT NULL default '0',
 PRIMARY KEY (extension)
);

CREATE TABLE playlists (
 listid SERIAL,
 uid int NOT NULL default '0',
 title varchar(255) NOT NULL default '',
 PRIMARY KEY (listid)
);

CREATE TABLE plentry (
 entryid SERIAL,
 listid int NOT NULL default '0',
 ndx int NOT NULL default '0',
 media text NOT NULL,
 PRIMARY KEY (entryid)
);

CREATE TABLE stats_daily (
 date bigint NOT NULL,
 browses bigint NOT NULL default '0',
 streams bigint NOT NULL default '0',
 downloads bigint NOT NULL default '0',
 PRIMARY KEY (date)
);

CREATE TABLE stats_media (
 path text NOT NULL,
 streams bigint NOT NULL default '0',
 downloads bigint NOT NULL default '0'
);

CREATE TABLE stats_user (
 uid bigint NOT NULL default '0',
 streams bigint NOT NULL default '0',
 downloads bigint NOT NULL default '0',
 PRIMARY KEY (uid)
);

CREATE TABLE streamlog (
 logid SERIAL,
 time bigint NOT NULL default '0',
 host varchar(255) NOT NULL default '',
 uname varchar(20) NOT NULL default '',
 media varchar(255) NOT NULL default '',
 PRIMARY KEY (logid)
);

CREATE TABLE users (
 uid SERIAL,
 uname varchar(20) NOT NULL default '',
 password varchar(20) NOT NULL default '',
 fname varchar(20) NOT NULL default '',
 lname varchar(20) NOT NULL default '',
 email varchar(40) NOT NULL default '',
 browse smallint NOT NULL default '0',
 stream smallint NOT NULL default '0',
 download smallint NOT NULL default '0',
 admin smallint NOT NULL default '0',
 xmmscmpt smallint NOT NULL default '0',
 PRIMARY KEY (uid)
);
