<?php
    require_once( "core/db/connectors/sqlite/SLDataBase.php" );
    
    if ( $sl_install_success )
    {
        $db = new SLDataBase( "", "", "", "" );
        $created = $db->createDataBase();
        
        if ( !$created )
        {
            $sl_install_success = false;
            $sl_install_errors[] = $db->getError();
        }
    }

    // If we still are ok, try to install the tables.
    if ( $sl_install_success )
    {
        $db = new SLDataBase( "", "", "", "" );
        $connected = $db->connect();
        
        if ( !$connected  )
        {
            $error = $db->getError();
            $sl_install_success = false;
            $sl_install_errors[] = "Could not connect to the database to create the tables ($error).";
        }
        else
        {
            $sql_file = file( "init_db/sql/sqlite.sql" );
            $tmp = implode( "", $sql_file );
            $sql_file = explode( ";", $tmp );

            $success = false;
            
            foreach( $sql_file as $line )
            {
                $line = trim( $line );
                
                if ( $line == "" || $line[0] == "#" )
                {
                    continue;
                }

                $success = $db->query( $line );

                if ( !$success )
                {
                    $sl_install_success = false;
                    $sl_install_errors[] = "Couldn't create table using SQL line: $line.<br>The server said: ".$db->getError();
                    break;
                }
            }
        }
    
        $db->close();
    }
    
    if ( isset( $db ) )
    {
        unset( $db );
    }
?>
