<?php
    require_once( "../sl_root.php" );
    require_once( "installer/config_check.php" );
    require_once( "installer/check_pre_install.php" );
    require_once( "core/SLConfiguration.php" );
    session_start();
    
    // Lets do a sanity check first to see if we will be able to do everything that we
    // want with the file system.
    
    $pre_install = checkPreInstall();
    
    if ( !$pre_install )
    {
        header( "Location: run_preinstall.php" );
        echo "\n";
    }
    
    // Create the media info cache dir
    if ( !is_dir( "../.media_info_cache" ) )
    {
        mkdir( "../.media_info_cache" );
    }
        
    
    $config = $_SESSION['SL_NEW_CONFIG'];
    $sl_install_errors = array();
    $sl_install_success = true;
   
    $db_type = $_SESSION['sl_install_db_type'];
    $db_host = $_SESSION['sl_install_db_host'];
    $db_user = $_SESSION['sl_install_db_user'];
    $db_pass = $_SESSION['sl_install_db_pass'];
    $db_name = $_SESSION['sl_install_db_name'];
            

   
    // Try to create the database, user, and tables.  This is specific
    // to the database type.
    if ( $sl_install_success )
    {
        require_once( "installer/init_db/$db_type.php" );
    }


    // Put all the data into the tables.  This includes the config options the
    // user chose, default options, the admin user, and other common info.
    if ( $sl_install_success )
    {
        require_once( "installer/init_db/init_table_data.php" );       
    }
    

    // Write out the htaccess files that are used for catching the 404 errors.
    if ( $sl_install_success )
    {
        require_once( "write_htaccess_files.php" );
    }
    

    // Finally write the db.conf.php file that will be used to access the
    // database.
    if ( $sl_install_success )
    {
        require_once( "installer/write_config_file.php" );
    }

    
    // If there were errors print them out, otherwise move on to the report
    // installation page.
    if ( !$sl_install_success )
    {
        require( "show_install_errors.php" );
        die();
    }
    else
    {
        require_once( "report_installation.php" );
    }
?>
