<?php
    require_once( "../sl_root.php" );
    require_once( "installer/config_check.php" );
    require_once( "core/SLConfiguration.php" );
    require_once( "core/platform/platform_require.php" );
    
    session_start();
    
    require_once( "core/platform/platform_init.php" );

    $rdbms_install = array( "database_config", "confirm_repair" );
    $sqlite_install = array( "confirm_repair" ); 
    
    // If the new config object doesn't exitst, lets create it.
    if ( !isset( $_SESSION['SL_NEW_CONFIG'] ) )
    {
        $config = &new SLConfiguration();

        $uri = stripslashes( $_SERVER['REQUEST_URI'] );
        $index = strpos( $uri, "installer/install_configure.php" );
        $root = substr( $uri, 0, $index  );
        $config->setMediaServerRoot( $root );
        
                
        if ( !isset( $_SESSION['sl_install_db_type'] ) )
        {
             $_SESSION['sl_install_db_type'] = "mysql";
             $_SESSION['sl_install_db_host'] = "localhost";
             $_SESSION['sl_install_db_user'] = "streamline";
             $_SESSION['sl_install_db_pass'] = "password";
             $_SESSION['sl_install_db_name'] = "streamline";
        }

        $_SESSION['SL_NEW_CONFIG'] = &$config;
    }
    else
    {
        $config = &$_SESSION['SL_NEW_CONFIG'];
    }
    
    // Figure out what path we are on for configuration. 
    switch ($_SESSION['dbms_type'])
    {
        case "rdbms":
            $sequence = $rdbms_install;
             break;

        case "sqlite":
            $sequence = $sqlite_install;
            break;

        default:
            header( "Location: dbms_type.php" );
            break;
    }
    
    $num_steps = count( $sequence );
    $_SESSION['sl_num_steps'] = $num_steps;
    
    if ( !isset( $_REQUEST['step_name'] ) )
    {
        $_SESSION['sl_cur_step_num'] = 0;
        header( "Location: ".( $sequence[0] ).".php" );
        echo "\n";
    }
    else
    {
        $step_name = $_REQUEST['step_name'];
        $step_num = 0;
        foreach( array_keys( $sequence ) as $key )
        {
            if ( $sequence[$key] == $step_name )
            {
                $step_num = $key;
                break;
            }
        }
    }

    
    if ( $step_num >= 0 && $step_num < count( $sequence ) )
    {
        switch ( $sequence[$step_num] )
        {
            
            case "database_config":
                $_SESSION['sl_install_db_type'] = $_REQUEST['db_type'];
                $_SESSION['sl_install_db_host'] = $_REQUEST['db_host'];
                $_SESSION['sl_install_db_user'] = $_REQUEST['db_user'];
                $_SESSION['sl_install_db_pass'] = $_REQUEST['db_pass'];
                $_SESSION['sl_install_db_name'] = $_REQUEST['db_name'];
                break;
            
            default:
                break;
        }
    }
    
    
    $nav = $_REQUEST['nav'];
     
    if ( !strcmp( $nav, "Next" ) )
    {
        if ( $step_num < $num_steps - 1 )
        {
            $step_num++;
            $_SESSION['sl_cur_step_num'] = $step_num;
            header( "Location: ".( $sequence[$step_num] ).".php" );
        }
    }
    else if ( !strcmp( $nav, "Back" ) )
    {
        if ( $step_num > 0 )
        {
            $step_num--;
            $_SESSION['sl_cur_step_num'] = $step_num;
            header( "Location: ".( $sequence[$step_num] ).".php" );
        }
        else if ( $step_num == 0 )
        {
            header( "Location: dbms_type.php" );
        }
    }
    else if ( !strcmp( $nav, "Repair" ) )
    {
        header( "Location: repair.php" );
    }
?>
