<?php
    require_once( "../../sl_root.php" );
    require_once( "core/SLConfiguration.php" );
    session_start();

    if ( isset( $_REQUEST['sl_upacks'] ) )
    {
        if ( strtolower( $_REQUEST['nav'] ) == "back" )
        {
            header( "Location: verify_version.php" );
            echo "\n";
            die();
        }
        
        if ( strtolower( $_REQUEST['nav'] ) == "upgrade" )
        {
            $_SESSION['sl_upacks'] = $_REQUEST['sl_upacks'];
            header( "Location: upgrade.php" );
            echo "\n";
            die();
        }
    }
    else
    {
        require_once( "sl_versions.php" );
        require_once( "upgrade_packs/upgrade_packs.php" );
        
        $sl_version = $_SESSION['sl_version'];


        // First we find what the next version was.  This is because
        // even if there is an upgrade pack with the same version as
        // the current one, we don't need it.  So our starting point
        // is the very next version.
        
        $the_key = array_search( $sl_version, $sl_versions );
        $the_key++;

        
        $first_pack = null;
        $count = count( $sl_versions );
        for ( $i = intval($the_key); $i < $count; $i++ )
        {
            $cur = $sl_versions[$i];
            if ( !(array_search( $cur, $upgrade_packs ) === false) )
            {
                $first_pack = $cur;
                break;
            }
        }
        
        // We found the first pack that applies, now lets make an array 
        // of all the rest.
        $pack_key = array_search( $first_pack, $upgrade_packs );
        $packs = array();

        $count = count( $upgrade_packs );
        for ( $i = $pack_key; $i < $count; $i++ )
        {
            $packs[] = $upgrade_packs[$i];
        }

        $db_types = array( 'sqlite' => 'SQLite', 'postgresql' => 'PostgreSQL', 'mysql' => 'MySQL' );
        require_once( "../installer.header.php" );

?>
      <h2 style="border-bottom: solid 1px black; padding-top: 20px">Streamline Installation Wizard: Upgrade</h2>
          <p>
            Pleas confirm your settings.  Click "Upgrade" to continue.
          </p>
          <p><strong>Database Configuration:</strong></p>
          <div style="padding-left: 15px" >
            <table bgcolor="#FFFFFF" cellpadding="3" style="border: solid 1px black">
              <tr bgcolor="#CCCCCC"><td><strong>Setting</strong></td><td><strong>Value</strong></td></tr>
              <tr bgcolor="#CCCCCC"><td>Database Type: </td><td align="center"><?php echo $db_types[$_SESSION['sl_db_type']]; ?></td></tr>
              <tr bgcolor="#CCCCCC"><td>Database Host: </td><td align="center"><?php echo $_SESSION['sl_db_host']; ?></td></tr>
              <tr bgcolor="#CCCCCC"><td>Database User: </td><td align="center"><?php echo $_SESSION['sl_db_user']; ?></td></tr>
              <tr bgcolor="#CCCCCC"><td>Database Password: </td><td align="center"><?php echo $_SESSION['sl_db_pass']; ?></td></tr>
              <tr bgcolor="#CCCCCC"><td>Database Name: </td><td align="center"><?php echo $_SESSION['sl_db_name']; ?></td></tr>
            </table>
          </div>
          <p><strong>Upgrades:</strong></p>
          <div style="padding-left: 15px" >
            <table bgcolor="#FFFFFF" cellpadding="3" style="border: solid 1px black">
              <tr bgcolor="#CCCCCC">
                <td><strong>From</strong></td><td><strong>To</strong></td><td>Details</td>
              </tr>
            <?
                for ( $i = 0; $i < count( $packs ); $i++ )
                {
                    $from = $i == 0?$sl_version:$packs[$i - 1];
                    $to = $packs[$i];
            ?>
              <tr bgcolor="#CCCCCC">
                <td><?php echo $from; ?></td><td><?php echo $to; ?></td><td><a href="upgrade_pack_details.php?sl_upack=<?php echo rawurlencode( $to ); ?>" target="_new">Details</a></td>
              </tr>
            <?
                }
            ?>
            </table>
          </div>
          <br>
          <hr>
          <form action="confirm_upgrade.php">
            <?php
              for( $i = 0; $i < count( $packs ); $i++ )
              {
                  $cur = $packs[$i];
                  echo "<input type=\"hidden\" name=\"sl_upacks[$i]\" value=\"$cur\">\n";
              }
            ?>
            <table>
              <tr>
                <td>
                  <input type="submit" name="nav" value="Back">
                  <input type="submit" name="nav" value="Upgrade">
                </td>
              </tr>
            </table>
          </form>
<?php
        require_once( "../installer.footer.php" );
    }
?>
