<?php
    require_once( "../../sl_root.php" );
    require_once( "installer/config_check.php" );
    require_once( "core/SLConfiguration.php" );
    
    session_start();
    
    if ( isset( $_REQUEST['db_type'] ) )
    {
        if ( strtolower( $_REQUEST['nav'] ) == "back" )
        {
            header( "Location: verify_config.php" );
            echo "\n";
            die();
        }

        if ( strtolower( $_REQUEST['nav'] ) == "next" )
        {
            $_SESSION['sl_db_type'] = $_REQUEST['db_type'];
            $_SESSION['sl_db_host'] = $_REQUEST['db_host'];
            $_SESSION['sl_db_user'] = $_REQUEST['db_user'];
            $_SESSION['sl_db_pass'] = $_REQUEST['db_pass'];
            $_SESSION['sl_db_name'] = $_REQUEST['db_name'];

            header( "Location: verify_version.php" );
            echo( "\n" );
            die();
        }
        
    }
    else
    {
    
        $db_type = $_SESSION['sl_db_type'];
        $db_host = $_SESSION['sl_db_host'];
        $db_user = $_SESSION['sl_db_user'];
        $db_pass = $_SESSION['sl_db_pass'];
        $db_name = $_SESSION['sl_db_name'];
        
        $db_types = array( 'sqlite' => 'SQLite', 'postgresql' => 'PostgreSQL', 'mysql' => 'MySQL' );
        $db_type_keys = array_keys( $db_types );
        
        require_once( "../installer.header.php" );
?>
      <h2 style="border-bottom: solid 1px black; padding-top: 20px">Streamline Installation Wizard: Upgrade</h2>
      <p>
        These values determines the way in which Streamline will connect to your RDBMS.  The Database and Database User that you specify here will be automatically created for you.
      </p>
      <form action="verify_config.php">
        <table class="config_table">
          <tr>
            <td colspan="2">
              <hr>
            </td>
          </tr>
          <tr>
            <td class="value_title">Database Type: </td>
            <td>
              <select name="db_type">
              <?php
                foreach( $db_type_keys as $key )
                {
                    echo "<option value=\"$key\"".(($db_type == $key)?" selected='selected":"").">".$db_types[$key]."</option>\n";
                }
              ?>
              </select>
            </td>
          </tr>
          <tr>
            <td class="value_title">Database Host: </td><td><input type="text" name="db_host" size="50" value="<?php echo $db_host; ?>"></td>
          </tr>
          <tr>
            <td class="value_title">Database User: </td><td><input type="text" name="db_user" size="50" value="<?php echo $db_user; ?>"></td>
          </tr>
          <tr>
            <td class="value_title">Database Password: </td><td><input type="text" name="db_pass" size="50" value="<?php echo $db_pass; ?>"></td>
          </tr>
          <tr>
            <td class="value_title">Database Name: </td><td><input type="text" name="db_name" size="50" value="<?php echo $db_name; ?>"></td>
          </tr>
          <tr>
            <td colspan="2" align="right">
              <hr>
              <input type="submit" name="nav" value="Back">
              <input type="submit" name="nav" value="Next">
            </td>
          </tr>
        </table>
      </form>
<?php
        require_once( "../installer.footer.php" );
    }
?>
