<?php
    require_once( "../../sl_root.php" );
    require_once( "installer/config_check.php" );
    require_once( "core/SLConfiguration.php" );
    
    session_start();
    
    if ( isset( $_REQUEST['sl_version'] ) )
    {
        if ( strtolower( $_REQUEST['nav'] ) == "back" )
        {
            //header( "Location: verify_config.php" );
            echo "\n";
            die();
        }

        if ( strtolower( $_REQUEST['nav'] ) == "next" )
        {
            $_SESSION['sl_version'] = $_REQUEST['sl_version'];
            header( "Location: confirm_upgrade.php" );
            echo( "\n" );
            die();
        }
    }
    else
    {
        $sl_db_type = $_SESSION['sl_db_type'];
        $sl_db_host = $_SESSION['sl_db_host'];
        $sl_db_user = $_SESSION['sl_db_user'];
        $sl_db_pass = $_SESSION['sl_db_pass'];
        $sl_db_name = $_SESSION['sl_db_name'];

        require_once( "core/db/connectors/$sl_db_type/SLDataBase.php" );

        $db = new SLDataBase( $sl_db_host, $sl_db_user, $sl_db_pass, $sl_db_name );
        $db->connect();
        
        require_once( "core/db/tables/SLConfigTable.php" );
        $table = &new SLConfigTable( $db );
        
        $version_opt = $table->getOption( "SLVersion" );
        $version = isset( $version_opt )?$version_opt->getValue():"1.0";
        
        $version_suffix_opt = $table->getOption( "SLVersionSuffix" );
        $version_suffix = isset( $version_suffix_opt )?$version_suffix_opt->getValue():"Beta2";

        $sl_version = "$version-$version_suffix";
        
        require_once( "sl_versions.php" );
        
        require_once( "../installer.header.php" );
?>
      <h2 style="border-bottom: solid 1px black; padding-top: 20px">Streamline Installation Wizard: Upgrade</h2>
      <p>
        These values determines the way in which Streamline will connect to your RDBMS.  The Database and Database User that you specify here will be automatically created for you.
      </p>
      <form action="verify_version.php">
        <table class="config_table">
          <tr>
            <td colspan="2">
              <hr>
            </td>
          </tr>
          <tr>
            <td class="value_title">Streamline Version: </td>
            <td>
              <select name="sl_version">
              <?php
                foreach( $sl_versions as $ver )
                {
                    echo "<option value=\"$ver\"".(($sl_version == $ver)?" selected='selected":"").">".$ver."</option>\n";
                }
              ?>
              </select>
            </td>
          </tr>
          <tr>
            <td colspan="2" align="right">
              <hr>
              <input type="submit" name="nav" value="Back">
              <input type="submit" name="nav" value="Next">
            </td>
          </tr>
        </table>
      </form>
<?php
        require_once( "../installer.footer.php" );
    }
?>
