<?php
    require_once( "../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "core/db/tables/SLMediaTable.php" );
    require_once( "core/search/SLSearchEngine.php" );
    require_once( "core/search/SLSearchRequest.php" );
    require_once( "core/search/SLSearchResult.php" );
    require_once( "core/theme/SLPageInfo.php" );
    require_once( "core/ui/nav/SLNavigator.php" );
    require_once( "core/streamline_functions.php" );
    require_once( "core/db/db_init.php" );
    
    $uri = stripslashes( $_SERVER['REQUEST_URI'] );
    $_SESSION[SL_CURRENT_URI] = $uri;
    
    require_once( "core/auth/cookie_login.php" );
    
    if ( $sl_access_controler->requireLoginForBrowsing() )
    {
        require_once( "core/auth/php_login.php" );
    }
    
    if ( !$sl_access_controler->getBrowseAccess() )
    {
        $msr = $sl_config->getMediaServerRoot();
        $ad_path = joinURLPath( $msr, "browse/access_denied.php" );
        header( "Location: $ad_path" );
        echo "\n";
        die();
    }

    $sl_theme_unix_path = $sl_cur_theme->getPath(); 
    $sl_theme_web_path = $sl_cur_theme->getWebPath();
    
    
    $search_type = array_key_exists( 'search_type', $_REQUEST )?$_REQUEST['search_type']:"";
    $searching = array_key_exists( 'searching', $_REQUEST )?$_REQUEST['searching']:"";

    $sl_user = null;
    
    if ( isset( $_SESSION[SL_AUTH_USER] ) )
    {
        $auth_user = $_SESSION[SL_AUTH_USER];
        
        require( "core/db/tables/SLUserTable.php" );
        $sl_user_table = new SLUserTable( $db );
        $sl_user = $sl_user_table->getUserById( $auth_user->getUID() );
    }
    
    $sl_page_info = &new SLPageInfo( SL_SEARCH_PAGE, "Search" );
    require_once( "core/theme/includes/search_header.php" );
    
    if ( $searching != "true" )
    {
        if ( $search_type == "advanced" )
        {
            $title_op = array_key_exists( 'title_op', $_REQUEST )?$_REQUEST['title_op']:"";
            $title_oprnd = array_key_exists( 'title_oprnd', $_REQUEST )?$_REQUEST['title_oprnd']:"";

            $artist_op = array_key_exists( 'artist_op', $_REQUEST )?$_REQUEST['artist_op']:"";
            $artist_oprnd = array_key_exists( 'artist_oprnd', $_REQUEST )?$_REQUEST['artist_oprnd']:"";

            $album_op = array_key_exists( 'album_op', $_REQUEST )?$_REQUEST['album_op']:"";
            $album_oprnd = array_key_exists( 'album_oprnd', $_REQUEST )?$_REQUEST['album_oprnd']:"";

            $genre_op = array_key_exists( 'genre_op', $_REQUEST )?$_REQUEST['genre_op']:"";
            $genre_oprnd = array_key_exists( 'genre_oprnd', $_REQUEST )?$_REQUEST['genre_oprnd']:"";

            $year_op = array_key_exists( 'year_op', $_REQUEST )?$_REQUEST['year_op']:"";
            $year_oprnd = array_key_exists( 'year_oprnd', $_REQUEST )?$_REQUEST['year_oprnd']:"";
            include( "advanced_search_form.inc.php" );
        }
        else
        {
            include( "simple_search_form.inc.php" );
        }

        require_once( "core/theme/includes/search_footer.php" );
    }
    else
    {
        // Lets Get All The Request Data fist so we can validate it.
          
        $num_per_page = array_key_exists( 'num_per_page', $_REQUEST )?$_REQUEST['num_per_page']:"";
        $page_num = array_key_exists( 'page_num', $_REQUEST )?$_REQUEST['page_num']:"";
        $search_engine = new SLSearchEngine( $db, $sl_config, $sl_media_info_cache );
        $num_results = 0;

        if ( $search_type == "advanced" )
        {
            $title_op = array_key_exists( 'title_op', $_REQUEST )?$_REQUEST['title_op']:"";
            $title_oprnd = array_key_exists( 'title_oprnd', $_REQUEST )?$_REQUEST['title_oprnd']:"";

            $artist_op = array_key_exists( 'artist_op', $_REQUEST )?$_REQUEST['artist_op']:"";
            $artist_oprnd = array_key_exists( 'artist_oprnd', $_REQUEST )?$_REQUEST['artist_oprnd']:"";

            $album_op = array_key_exists( 'album_op', $_REQUEST )?$_REQUEST['album_op']:"";
            $album_oprnd = array_key_exists( 'album_oprnd', $_REQUEST )?$_REQUEST['album_oprnd']:"";

            $genre_op = array_key_exists( 'genre_op', $_REQUEST )?$_REQUEST['genre_op']:"";
            $genre_oprnd = array_key_exists( 'genre_oprnd', $_REQUEST )?$_REQUEST['genre_oprnd']:"";

            $year_op = array_key_exists( 'year_op', $_REQUEST )?$_REQUEST['year_op']:"";
            $year_oprnd = array_key_exists( 'year_oprnd', $_REQUEST )?$_REQUEST['year_oprnd']:"";

            $request = new SLSearchRequest();    

            if ( $title_oprnd != "" )
            {
                $request->setTitleCriteria( $title_oprnd, $title_op );
                $at_least_one = true;
            }
            
            if ( $artist_oprnd != "" )
            {
                $request->setArtistCriteria( $artist_oprnd, $artist_op );
                $at_least_one = true;
            }

            if ( $album_oprnd != "" )
            {
                $request->setAlbumCriteria( $album_oprnd, $album_op );
                $at_least_one = true;
            }
            
            if ( $year_oprnd != "" )
            {
                $request->setYearCriteria( $year_oprnd, $year_op );
                $at_least_one = true;
            }
            
            if ( $genre_oprnd != "" )
            {
                $request->setGenreCriteria( $genre_oprnd, $genre_op );
                $at_least_one = true;
            }
            
            $num_results = $search_engine->performAdvancedSearch( $request, $num_per_page, $page_num );
            
            include( "advanced_search_form.inc.php" );
        }
        else
        {
            $search_string = array_key_exists( 'search_string', $_REQUEST )?$_REQUEST['search_string']:"";

            if ( $search_string != "" )
            {
                $num_results = $search_engine->performSimpleSearch( $search_string, $num_per_page, $page_num );
            }
            
            include( "simple_search_form.inc.php" );
        }
        
        $search_results = $search_engine->getResults();
      
       
        include( "results.inc.php" );
        require_once( "core/theme/includes/search_footer.php" );
    }
?>
